var opd_saving = false;
function opd_switch_gdpr() {
	if (jQuery("#opd_gdpr_enable").is(":checked")) {
		jQuery(".opd-gdpr-depend").fadeIn(200);
	} else {
		jQuery(".opd-gdpr-depend").fadeOut(200);
	}
}
function opd_change_source(_object) {
	var source = jQuery("input[name=source]:checked").val();
	jQuery(".opd-source-data").hide();
	jQuery(".opd-source-"+source).fadeIn(200);
}
function opd_set_media(_object) {
	var input = _object;
	var media_frame = wp.media({
		title: 'Select File',
		library: {
		},
		multiple: false
	});
	media_frame.on("select", function() {
		var attachment = media_frame.state().get("selection").first();
		jQuery(input).val(attachment.attributes.filename);
		jQuery(input).parent().find("input[type=hidden]").val(attachment.attributes.id);
	});
	media_frame.open();
}
var opd_uploading = false;
function opd_uploader_start(_object) {
	var iframe_id = jQuery(_object).attr("target");
	var button_id = jQuery(_object).attr("data-button");
	jQuery("#"+iframe_id).attr("data-loading", "true");
	jQuery("#"+button_id+" label").text(jQuery("#"+button_id).attr("data-loading"));
	jQuery("#"+button_id+" i").attr("class", "opd-fa opd-fa-spinner opd-fa-spin");
}
function opd_uploader_finish(_object) {
	if (jQuery(_object).attr("data-loading") != "true") return false;
	jQuery(_object).attr("data-loading", "false");
	var button_id = jQuery(_object).attr("data-button");
	jQuery("#"+button_id+" i").attr("class", "opd-fa opd-fa-upload");
	jQuery("#"+button_id+" label").text(jQuery("#"+button_id).attr("data-label"));
	var return_data = jQuery(_object).contents().find("html").text();
	try {
		var data;
		if (typeof return_data == 'object') data = return_data;
		else data = jQuery.parseJSON(return_data);
		if (data.status == "OK") {
			var select_id = jQuery("#"+button_id).attr("data-select");
			console.log(data.html);
			jQuery("#"+select_id).html(data.html);
			opd_global_message_show("success", data.message);
		} else if (data.status == "ERROR") {
			opd_global_message_show("danger", data.message);
		} else {
			opd_global_message_show("danger", opd_esc_html__("Something went wrong. We got unexpected server response."));
		}
	} catch(error) {
		opd_global_message_show("danger", opd_esc_html__("Something went wrong. We got unexpected server response."));
	}
}
function opd_save_settings(_button) {
	if (opd_saving) return false;
	opd_saving = true;
	var button_object = _button;
	jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-spinner opd-fa-spin");
	jQuery(button_object).addClass("opd-button-disabled");
	jQuery(".opd-message").slideUp(350);
	jQuery.ajax({
		type	: "POST",
		url		: opd_ajax_handler, 
		data	: jQuery(".opd-form").serialize(),
		success	: function(return_data) {
			jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-ok");
			jQuery(button_object).removeClass("opd-button-disabled");
			var data;
			try {
				var data = jQuery.parseJSON(return_data);
				if (data.status == "OK") {
					opd_global_message_show('success', data.message);
				} else if (data.status == "ERROR") {
					jQuery(".opd-message").html(data.message);
					jQuery(".opd-message").slideDown(350);
				} else {
					jQuery(".opd-message").html("Something went wrong. We got unexpected server response.");
					jQuery(".opd-message").slideDown(350);
				}
			} catch(error) {
				jQuery(".opd-message").html("Something went wrong. We got unexpected server response.");
				jQuery(".opd-message").slideDown(350);
			}
			opd_saving = false;
		},
		error	: function(XMLHttpRequest, textStatus, errorThrown) {
			jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-ok");
			jQuery(button_object).removeClass("opd-button-disabled");
			jQuery(".opd-message").html("Something went wrong. We got unexpected server response.");
			jQuery(".opd-message").slideDown(350);
			opd_saving = false;
		}
	});
	return false;
}
function opd_save_file(_button) {
	if (opd_saving) return false;
	opd_saving = true;
	var button_object = _button;
	jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-spinner opd-fa-spin");
	jQuery(button_object).addClass("opd-button-disabled");
	jQuery(".opd-message").slideUp(350);
	jQuery.ajax({
		type	: "POST",
		url		: opd_ajax_handler, 
		data	: jQuery(".opd-form").serialize(),
		success	: function(return_data) {
			jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-ok");
			jQuery(button_object).removeClass("opd-button-disabled");
			var data;
			try {
				var data = jQuery.parseJSON(return_data);
				if (data.status == "OK") {
					opd_global_message_show('success', data.message);
					location.href = data.redirect;
				} else if (data.status == "ERROR") {
					opd_global_message_show('danger', data.message);
				} else {
					opd_global_message_show('danger', data.message);
				}
			} catch(error) {
				opd_global_message_show('danger', "Something went wrong. We got unexpected server response.");
			}
			opd_saving = false;
		},
		error	: function(XMLHttpRequest, textStatus, errorThrown) {
			jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-ok");
			jQuery(button_object).removeClass("opd-button-disabled");
			opd_global_message_show('danger', "Something went wrong. We got unexpected server response.");
			opd_saving = false;
		}
	});
	return false;
}
var opd_global_message_timer;
function opd_global_message_show(_type, _message) {
	clearTimeout(opd_global_message_timer);
	jQuery("#opd-global-message").fadeOut(300, function() {
		jQuery("#opd-global-message").attr("class", "");
		jQuery("#opd-global-message").addClass("opd-global-message-"+_type).html(_message);
		jQuery("#opd-global-message").fadeIn(300);
		opd_global_message_timer = setTimeout(function(){jQuery("#opd-global-message").fadeOut(300);}, 5000);
	});
}
function opd_aweber_connect(_button) {
	var button_object = _button;
	jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-spinner opd-fa-spin");
	jQuery(button_object).addClass("opd-button-disabled");
	var post_data = {action: "opd-aweber-connect", opd_aweber_oauth_id: jQuery("#opd_aweber_oauth_id").val()};
	jQuery.ajax({
		type	: "POST",
		url		: opd_ajax_handler, 
		data	: post_data,
		success	: function(return_data) {
			jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-ok");
			jQuery(button_object).removeClass("opd-button-disabled");
			try {
				//alert(return_data);
				var data = jQuery.parseJSON(return_data);
				var status = data.status;
				if (status == "OK") {
					jQuery("#opd-aweber-group").slideUp(350, function() {
						jQuery("#opd-aweber-group").html(data.html);
						jQuery("#opd-aweber-group").slideDown(350);
					});
				} else if (status == "ERROR") {
					opd_global_message_show('danger', data.message);
				} else {
					opd_global_message_show('danger', "Something went wrong. We got unexpected server response.");
				}
			} catch(error) {
				opd_global_message_show('danger', "Something went wrong. We got unexpected server response.");
			}
		},
		error	: function(XMLHttpRequest, textStatus, errorThrown) {
			jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-ok");
			jQuery(button_object).removeClass("opd-button-disabled");
			opd_global_message_show('danger', "Something went wrong. We got unexpected server response.");
		}
	});
	return false;
}
function opd_aweber_disconnect(_button) {
	var button_object = _button;
	jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-spinner opd-fa-spin");
	jQuery(button_object).addClass("opd-button-disabled");
	var post_data = {action: "opd-aweber-disconnect"};
	jQuery.ajax({
		type	: "POST",
		url		: opd_ajax_handler, 
		data	: post_data,
		success	: function(return_data) {
			jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-ok");
			jQuery(button_object).removeClass("opd-button-disabled");
			try {
				//alert(return_data);
				var data = jQuery.parseJSON(return_data);
				var status = data.status;
				if (status == "OK") {
					jQuery("#opd-aweber-group").slideUp(350, function() {
						jQuery("#opd-aweber-group").html(data.html);
						jQuery("#opd-aweber-group").slideDown(350);
					});
				} else if (status == "ERROR") {
					opd_global_message_show('danger', data.message);
				} else {
					opd_global_message_show('danger', "Something went wrong. We got unexpected server response.");
				}
			} catch(error) {
				opd_global_message_show('danger', "Something went wrong. We got unexpected server response.");
			}
		},
		error	: function(XMLHttpRequest, textStatus, errorThrown) {
			jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-ok");
			jQuery(button_object).removeClass("opd-button-disabled");
			opd_global_message_show('danger', "Something went wrong. We got unexpected server response.");
		}
	});
	return false;
}
function opd_mailchimp_loadgroups(_button) {
	var button_object = _button;
	jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-spinner opd-fa-spin");
	jQuery(button_object).addClass("opd-button-disabled");
	jQuery(".opd-mailchimp-groups-html").slideUp(350);
	var data = {action: "opd-mailchimp-groups", opd_key: jQuery("#opd_mailchimp_api_key").val(), opd_list: jQuery("#opd-mailchimp-list-id").val()};
	jQuery.post(opd_ajax_handler, data, function(return_data) {
		jQuery(button_object).find("i").attr("class", "opd-fa opd-fa-ok");
		jQuery(button_object).removeClass("opd-button-disabled");
		try {
			var data = jQuery.parseJSON(return_data);
			var status = data.status;
			if (status == "OK") {
				jQuery(".opd-mailchimp-groups-html").html(data.html);
				jQuery(".opd-mailchimp-groups-html").slideDown(350);
			} else {
				jQuery(".opd-mailchimp-groups-html").html("<div class=\'opd-mailchimp-grouping\' style=\'margin-bottom: 10px;\'><strong>Internal error! Can not connect to MailChimp server.</strong></div>");
				jQuery(".opd-mailchimp-groups-html").slideDown(350);
			}
		} catch(error) {
			jQuery(".opd-mailchimp-groups-html").html("<div class=\'opd-mailchimp-grouping\' style=\'margin-bottom: 10px;\'><strong>Internal error! Can not connect to MailChimp server.</strong></div>");
			jQuery(".opd-mailchimp-groups-html").slideDown(350);
		}
	});
	return false;
}

function opd_input_options_focus(object, post) {
	var base_id = jQuery(object).attr("id");
	var action = jQuery(object).attr("data-action");
	if (jQuery("#"+base_id+"-items").hasClass("opd-visible")) {
	} else {
		jQuery("#"+base_id+"-items").find(".opd-options-list-spinner").fadeIn(300);
		jQuery("#"+base_id+"-items").find(".opd-options-list-data").html("");
		jQuery("#"+base_id+"-items").removeClass("opd-vertical-scroll");
		jQuery("#"+base_id+"-items").fadeIn(300);
		jQuery("#"+base_id+"-items").addClass("opd-visible");
		jQuery.post(opd_ajax_handler, post, function(return_data) {
			jQuery("#"+base_id+"-items").find(".opd-options-list-spinner").hide();
			try {
				var data = jQuery.parseJSON(return_data);
				var status = data.status;
				if (status == "OK") {
					jQuery("#"+base_id+"-items").find(".opd-options-list-data").html(data.html);
					if (data.hasOwnProperty("items")) {
						if (data.items > 4) jQuery("#"+base_id+"-items").addClass("opd-vertical-scroll");
					} else {
						jQuery(jQuery(object).parent()).find("input").val("");
					}
				} else {
					jQuery("#"+base_id+"-items").find(".opd-options-list-data").html("<div style='text-align: center;'><strong>Internal error! Can not connect to server.</strong></div>");
					jQuery(jQuery(object).parent()).find("input").val("");
				}
			} catch(error) {
				jQuery("#"+base_id+"-items").find(".opd-options-list-data").html("<div style='text-align: center;'><strong>Internal error! Can not connect to server.</strong></div>");
				jQuery(jQuery(object).parent()).find("input").val("");
			}
		});
	}
}
function opd_input_options_blur(object) {
	var base_id = jQuery(object).attr("id");
	jQuery("#"+base_id+"-items").removeClass("opd-visible");
	jQuery("#"+base_id+"-items").fadeOut(300);
}
function opd_input_options_selected(object) {
	var item_id = jQuery(object).attr("data-id");
	var item_title = jQuery(object).attr("data-title");
	var base_id = jQuery(object).closest(".opd-options-list").attr("id");
	base_id = base_id.replace("-items", "");
	jQuery("#"+base_id).val(item_title);
	jQuery("#"+base_id+"-id").val(item_id);
	return false;
}
/* Modal Popup - begin */
var opd_modal_buttons_disable = false;
function opd_modal_open(_settings) {
	var settings = {
		width: 				480,
		height:				180,
		ok_label:			'Yes',
		cancel_label:		'Cancel',
		message:			'Do you really want to continue?',
		ok_function:		function() {opd_modal_close();},
		cancel_function:	function() {opd_modal_close();}
	}
	var objects = [settings, _settings],
    settings = objects.reduce(function (r, o) {
		Object.keys(o).forEach(function (k) {
			r[k] = o[k];
		});
		return r;
    }, {});
	
	opd_modal_buttons_disable = false;
	jQuery(".opd-modal-message").html(settings.message);
	jQuery(".opd-modal").width(settings.width);
	jQuery(".opd-modal").height(settings.height);
	jQuery(".opd-modal-content").width(settings.width);
	jQuery(".opd-modal-content").height(settings.height);
	jQuery(".opd-modal-button").unbind("click");
	jQuery(".opd-modal-button").removeClass("opd-modal-button-disabled");
	jQuery("#opd-modal-button-ok").find("label").html(settings.ok_label);
	jQuery("#opd-modal-button-cancel").find("label").html(settings.cancel_label);
	jQuery("#opd-modal-button-ok").bind("click", function(e){
		e.preventDefault();
		if (!opd_modal_buttons_disable && typeof settings.ok_function == "function") {
			settings.ok_function();
		}
	});
	jQuery("#opd-modal-button-cancel").bind("click", function(e){
		e.preventDefault();
		if (!opd_modal_buttons_disable && typeof settings.cancel_function == "function") {
			settings.cancel_function();
		}
	});
	jQuery(".opd-modal-overlay").fadeIn(300);
	jQuery(".opd-modal").css({
		'top': 					'50%',
		'transform': 			'translate(-50%, -50%) scale(1)',
		'-webkit-transform': 	'translate(-50%, -50%) scale(1)'
	});
}
function opd_modal_close() {
	jQuery(".opd-modal-overlay").fadeOut(300);
	jQuery(".opd-modal").css({
		'transform': 			'translate(-50%, -50%) scale(0)',
		'-webkit-transform': 	'translate(-50%, -50%) scale(0)'
	});
	setTimeout(function(){jQuery(".opd-modal").css("top", "-3000px")}, 300);
}
/* Modal Popup - end */
function opd_confirm_redirect(_object, _action) {
	var message, button_label;
	if (_action == "delete") {
		message = 'Please confirm that you want to delete the item.';
		button_label = 'Delete';
	} else if (_action == "delete-all") {
		message = 'Please confirm that you want to delete all items.';
		button_label = 'Delete';
	} else {
		message = 'Please confirm that you want to perform this action.';
		button_label = 'Continue';
	}
	opd_modal_open({
		message:		message,
		ok_label:		button_label,
		ok_function:	function(e) {
			opd_modal_close();
			location.href = jQuery(_object).attr("href");
		}
	});
	return false;
}

function opd_admin_popup_resize() {
	if (opd_record_active) {
		var popup_height = 2*parseInt((jQuery(window).height() - 100)/2, 10);
		var popup_width = Math.min(Math.max(2*parseInt((jQuery(window).width() - 300)/2, 10), 640), 1080);
		jQuery("#opd-admin-popup").height(popup_height);
		jQuery("#opd-admin-popup").width(popup_width);
		jQuery("#opd-admin-popup .opd-admin-popup-inner").height(popup_height);
		jQuery("#opd-admin-popup .opd-admin-popup-content").height(popup_height - 52);
	}
}
function opd_admin_popup_ready() {
	opd_admin_popup_resize();
	jQuery(window).resize(function() {
		opd_admin_popup_resize();
	});
}

var opd_record_active = null;
function opd_admin_popup_open(_object) {
	var action = jQuery(_object).attr("data-action");
	if (typeof action == typeof undefined) return false;
	jQuery("#opd-admin-popup .opd-admin-popup-content-form").html("");
	var window_height = 2*parseInt((jQuery(window).height() - 100)/2, 10);
	var window_width = Math.min(Math.max(2*parseInt((jQuery(window).width() - 300)/2, 10), 640), 1080);
	jQuery("#opd-admin-popup").height(window_height);
	jQuery("#opd-admin-popup").width(window_width);
	jQuery("#opd-admin-popup .opd-admin-popup-inner").height(window_height);
	jQuery("#opd-admin-popup .opd-admin-popup-content").height(window_height - 52);
	jQuery("#opd-admin-popup-overlay").fadeIn(300);
	jQuery("#opd-admin-popup").css({
		'top': 					'50%',
		'transform': 			'translate(-50%, -50%) scale(1)',
		'-webkit-transform': 	'translate(-50%, -50%) scale(1)'
	});
	var title = jQuery(_object).attr("data-title");
	if (typeof title != typeof undefined) jQuery("#opd-admin-popup .opd-admin-popup-title h3 label").html(title);
	var subtitle = jQuery(_object).attr("data-subtitle");
	if (typeof subtitle != typeof undefined) jQuery("#opd-admin-popup .opd-admin-popup-title h3 span").html(subtitle);
	jQuery("#opd-admin-popup .opd-admin-popup-loading").show();
	opd_record_active = true;
	var post_data = {"action" : action, "param1" : jQuery(_object).attr("data-param1"), "param2" : jQuery(_object).attr("data-param2"), "param3" : jQuery(_object).attr("data-param3")};
	jQuery.ajax({
		type	: "POST",
		url		: opd_ajax_handler, 
		data	: post_data,
		success	: function(return_data) {
			try {
				var data;
				if (typeof return_data == 'object') data = return_data;
				else data = jQuery.parseJSON(return_data);
				if (data.status == "OK") {
					jQuery("#opd-admin-popup .opd-admin-popup-content-form").html(data.html);
					jQuery("#opd-admin-popup .opd-admin-popup-loading").hide();
				} else if (data.status == "ERROR") {
					opd_admin_popup_close();
					opd_global_message_show("danger", data.message);
				} else {
					opd_admin_popup_close();
					opd_global_message_show("danger", opd_esc_html__("Something went wrong. We got unexpected server response."));
				}
			} catch(error) {
				opd_admin_popup_close();
				opd_global_message_show("danger", opd_esc_html__("Something went wrong. We got unexpected server response."));
			}
		},
		error	: function(XMLHttpRequest, textStatus, errorThrown) {
			opd_admin_popup_close();
			opd_global_message_show("danger", opd_esc_html__("Something went wrong. We got unexpected server response."));
		}
	});

	return false;
}
function opd_admin_popup_close() {
	jQuery("#opd-admin-popup-overlay").fadeOut(300);
	jQuery("#opd-admin-popup").css({
		'transform': 			'translate(-50%, -50%) scale(0)',
		'-webkit-transform': 	'translate(-50%, -50%) scale(0)'
	});
	opd_record_active = null;
	setTimeout(function(){jQuery("#opd-admin-popup .opd-admin-popup-content-form").html(""); jQuery("#opd-admin-popup").css("top", "-3000px")}, 1000);
	return false;
}
function opd_esc_html__(_string) {
	var string;
	if (typeof opd_translations == typeof {} && opd_translations.hasOwnProperty(_string)) {
		string = opd_translations[_string];
		if (string.length == 0) string = _string;
	} else string = _string;
	return opd_escape_html(string);
}
function opd_escape_html(_text) {
	if (!_text) return "";
	var map = {
		'&': '&amp;',
		'<': '&lt;',
		'>': '&gt;',
		'"': '&quot;',
		"'": '&#039;'
	};
	return _text.replace(/[&<>"']/g, function(m) { return map[m]; });
}
function opd_utf8encode(string) {
	string = string.replace(/\x0d\x0a/g, "\x0a");
	var output = "";
	for (var n = 0; n < string.length; n++) {
		var c = string.charCodeAt(n);
		if (c < 128) {
			output += String.fromCharCode(c);
		} else if ((c > 127) && (c < 2048)) {
			output += String.fromCharCode((c >> 6) | 192);
			output += String.fromCharCode((c & 63) | 128);
		} else {
			output += String.fromCharCode((c >> 12) | 224);
			output += String.fromCharCode(((c >> 6) & 63) | 128);
			output += String.fromCharCode((c & 63) | 128);
		}
	}
	return output;
}
function opd_encode64(input) {
	var keyString = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	var output = "";
	var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
	var i = 0;
	input = opd_utf8encode(input);
	while (i < input.length) {
		chr1 = input.charCodeAt(i++);
		chr2 = input.charCodeAt(i++);
		chr3 = input.charCodeAt(i++);
		enc1 = chr1 >> 2;
		enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
		enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
		enc4 = chr3 & 63;
		if (isNaN(chr2)) {
			enc3 = enc4 = 64;
		} else if (isNaN(chr3)) {
			enc4 = 64;
		}
		output = output + keyString.charAt(enc1) + keyString.charAt(enc2) + keyString.charAt(enc3) + keyString.charAt(enc4);
	}
	return output;
}
function opd_utf8decode(input) {
	var string = "";
	var i = 0;
	var c = c1 = c2 = 0;
	while ( i < input.length ) {
		c = input.charCodeAt(i);
		if (c < 128) {
			string += String.fromCharCode(c);
			i++;
		} else if ((c > 191) && (c < 224)) {
			c2 = input.charCodeAt(i+1);
			string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
			i += 2;
		} else {
			c2 = input.charCodeAt(i+1);
			c3 = input.charCodeAt(i+2);
			string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
			i += 3;
		}
	}
	return string;
}
function opd_decode64(input) {
	var keyString = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	var output = "";
	var chr1, chr2, chr3;
	var enc1, enc2, enc3, enc4;
	var i = 0;
	input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	while (i < input.length) {
		enc1 = keyString.indexOf(input.charAt(i++));
		enc2 = keyString.indexOf(input.charAt(i++));
		enc3 = keyString.indexOf(input.charAt(i++));
		enc4 = keyString.indexOf(input.charAt(i++));
		chr1 = (enc1 << 2) | (enc2 >> 4);
		chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
		chr3 = ((enc3 & 3) << 6) | enc4;
		output = output + String.fromCharCode(chr1);
		if (enc3 != 64) {
			output = output + String.fromCharCode(chr2);
		}
		if (enc4 != 64) {
			output = output + String.fromCharCode(chr3);
		}
	}
	output = opd_utf8decode(output);
	return output;
}
jQuery(document).ready(function(){
	jQuery(".opd-tabs").each(function() {
		var tabs = this;
		jQuery(tabs).find("a").on("click", function(e) {
			if (jQuery(this).hasClass("opd-tab-active")) {
			} else {
				var active_tab = jQuery(tabs).find(".opd-tab-active").attr("href");
				var tab = jQuery(this).attr("href");
				jQuery(tabs).find(".opd-tab-active").removeClass("opd-tab-active");
				jQuery(this).addClass("opd-tab-active");
				jQuery(active_tab).fadeOut(300, function(){
					jQuery(tab).fadeIn(300);
				});
			}
			return false;
		});
	});
});