<?php
/*
Plugin Name: Opt-In Downloads
Plugin URI: https://codecanyon.net/item/subscribe-download/2687305?ref=halfdata
Description: Ask users to submit name/email and send download link to them. The only action you have do is to insert shortcode like <code>[sdfile url="http://..."]</code> into your posts or pages.
Version: 4.04
Author: 20script
Author URI: https://www.20script.ir
*/
define('OPD_RECORDS_PER_PAGE', '40');
define('OPD_VERSION', 4.04);
define('OPD_AWEBER_APPID', '577391a0');
define('OPD_UPLOADS_DIR', 'optin-downloads');

register_activation_hook(__FILE__, array("opd_class", "install"));
register_deactivation_hook(__FILE__, array("opd_class", "uninstall"));

class opd_class {
	var $options, $default_file_options;
	
	function __construct() {
		if (function_exists('load_plugin_textdomain')) {
			load_plugin_textdomain('opd', false, dirname(plugin_basename(__FILE__)).'/languages/');
		}
		
		$this->options = array (
			"version" => OPD_VERSION,
			"intro" => __('Complete your name and email to receive free item.', 'opd'),
			"button_label" => __('Get Download Link', 'opd'),
			"placeholder_email" => __('Enter your e-mail...', 'opd'),
			"placeholder_name" => __('Enter your name...', 'opd'),
			'box_color' => '#F8F8F8',
			'box_border_color' => '#CCCCCC',
			'box_font_color' => '#333333',
			'box_font_size' => 15,
			'button_color' => '#0147A3',
			'button_font_color' => '#FFFFFF',
			'button_font_size' => 15,
			'input_font_color' => '#333333',
			'input_font_size' => 15,
			'input_border_color' => '#444444',
			'input_background_color' => '#FFFFFF',
			'input_background_opacity' => 0.7,
			"from_name" => get_bloginfo("name"),
			"from_email" => "noreply@".str_replace("www.", "", $_SERVER["SERVER_NAME"]),
			"thanks_message" => __('Thank you. Download link was sent to {email}.', 'opd'),
			"thanksgiving_enable" => "on",
			"thanksgiving_email_subject" => __('Get your freebie', 'opd'),
			"thanksgiving_email_body" => __('Dear {name},', 'opd').PHP_EOL.PHP_EOL.__('Thank you for subscription. Click the link below to download the item:', 'opd').PHP_EOL.'{download_link}'.PHP_EOL.PHP_EOL.__('Thanks,', 'opd').PHP_EOL.get_bloginfo("name"),
			"csv_separator" => ";",
			'email_validation' => "off",
			"disable_name" => "off",
			"link_lifetime" => "48",
			"mail_enable" => "off",
			"mail_email" => "",
			"mail_subject" => __('New subscriber', 'opd'),
			"mail_message" => __('Dear Administrator,', 'opd').PHP_EOL.PHP_EOL.__('This is a notification about new subscriber.', 'opd').PHP_EOL.PHP_EOL.'<strong>Name:</strong> {name}'.PHP_EOL.'<strong>E-mail:</strong> {e-mail}'.PHP_EOL.'<strong>IP:</strong> {ip}'.PHP_EOL.'<strong>Source:</strong> {source}'.PHP_EOL.'<strong>Download link:</strong> {download_link}'.PHP_EOL.PHP_EOL.__('Thanks,', 'opd').PHP_EOL.get_bloginfo("name"),
			"mail_from" => "off",
			"mailchimp_enable" => "off",
			"mailchimp_api_key" => "",
			"mailchimp_list" => "",
			"mailchimp_list_id" => "",
			"mailchimp_double" => "off",
			"icontact_enable" => "off",
			"icontact_appid" => "",
			"icontact_apiusername" => "",
			"icontact_apipassword" => "",
			'icontact_listid' => "",
			'campaignmonitor_enable' => "off",
			'campaignmonitor_api_key' => '',
			'campaignmonitor_list_id' => '',
			'getresponse_enable' => "off",
			'getresponse_api_key' => '',
			"getresponse_list" => "",
			"getresponse_list_id" => "",
			'aweber_enable' => "off",
			'aweber_consumer_key' => "",
			'aweber_consumer_secret' => "",
			'aweber_access_key' => "",
			'aweber_access_secret' => "",
			'aweber_listid' => "",
			'madmimi_enable' => 'off',
			'madmimi_login' => '',
			'madmimi_api_key' => '',
			'madmimi_list_id' => '',
			'mymail_enable' => "off",
			'mymail_listid' => "",
			'mymail_double' => "off",
			'sendy_enable' => 'off',
			'sendy_url' => '',
			'sendy_listid' => '',
			'benchmark_enable' => 'off',
			'benchmark_api_key' => '',
			'benchmark_list_id' => '',
			'benchmark_double' => 'off',
			"ga_tracking" => "off",
			"gdpr_enable" => "on",
			"gdpr_title" => __('I agree with the {Terms & Conditions}', 'opd'),
			"terms" => __('Drop your Terms & Conditions here.', 'opd'),
			"xsendfile" => "off",
			"expired_url" => get_bloginfo('url'),
			"media_secure" => "on",
			"amazon_access_key" => "",
			"amazon_secret_key" => "",
			"amazon_bucket" => ""
		);

		$this->default_file_options = array (
			"welcome-email-custom" => "off",
			"welcome-email-subject" => __('Get your freebie', 'opd'),
			"welcome-email-body" => __('Dear {name},', 'opd').PHP_EOL.PHP_EOL.__('Thank you for subscription. Click the link below to download the item:', 'opd').PHP_EOL.'{download_link}'.PHP_EOL.PHP_EOL.__('Thanks,', 'opd').PHP_EOL.get_bloginfo("name")
		);
		$this->get_options();
		
		if (is_admin()) {
			if ($this->options['version'] < 4.01) add_action('admin_notices', array(&$this, 'admin_warning'));
			add_action('wpmu_new_blog', array(&$this, 'install_new_blog'), 10, 6);
			add_action('delete_blog', array(&$this, 'uninstall_blog'), 10, 2);
			add_action('admin_enqueue_scripts', array(&$this, 'admin_enqueue_scripts'));
			add_action('admin_menu', array(&$this, 'admin_menu'));
			add_action('admin_head', array(&$this, 'admin_head'));
			add_action('init', array(&$this, 'admin_request_handler'));
			add_action('wp_ajax_opd-submit', array(&$this, "front_submit"));
			add_action('wp_ajax_nopriv_opd-submit', array(&$this, "front_submit"));
			add_action('wp_ajax_opd-aweber-connect', array(&$this, "aweber_connect"));
			add_action('wp_ajax_opd-aweber-disconnect', array(&$this, "aweber_disconnect"));
			add_action('wp_ajax_opd-save-settings', array(&$this, "admin_save_settings"));
			add_action('wp_ajax_opd-save-file', array(&$this, "admin_save_file"));
			add_action('wp_ajax_opd-file-upload', array(&$this, "admin_upload"));
			add_action('wp_ajax_opd-mailchimp-lists', array(&$this, "mailchimp_show_lists"));
			add_action('wp_ajax_opd-mailchimp-groups', array(&$this, "mailchimp_show_groups"));
			add_action('wp_ajax_opd-getresponse-lists', array(&$this, "getresponse_show_lists"));
			add_filter("attachment_fields_to_edit", array(&$this, 'add_attachment_fields_to_edit'), null, 2);
			add_filter('wp_privacy_personal_data_exporters', array(&$this, 'personal_data_exporters'), 2);
			add_filter('wp_privacy_personal_data_erasers', array(&$this, 'personal_data_erasers'), 2);
			add_action('wp_ajax_opd-madmimi-lists', array(&$this, "admin_madmimi_lists"));
			add_action('wp_ajax_opd-benchmark-lists', array(&$this, "admin_benchmark_lists"));
			add_action('wp_ajax_opd-icontact-lists', array(&$this, "admin_icontact_lists"));
			add_action('wp_ajax_opd-remote-init', array(&$this, "remote_init"));
			add_action('wp_ajax_nopriv_opd-remote-init', array(&$this, "remote_init"));
		} else {
			add_action('init', array(&$this, 'front_init'));
			add_shortcode('sdfile', array(&$this, "shortcode_sdfile_handler"));
			add_shortcode('opd', array(&$this, "shortcode_opd_handler"));
		}
	}

	function admin_warning() {
		echo '
		<div class="error opd-error opd-error-animated"><p><strong>IMPORTANT!</strong> Please deactivate and activate <strong>Opt-In Downloads</strong> plugin <a href="'.admin_url('plugins.php').'">here</a>! It is necessary to sync database for additional functionality.</p></div>';
	}

	function admin_enqueue_scripts() {
		wp_enqueue_script("jquery");
		wp_enqueue_style('opd', plugins_url('/css/admin.css', __FILE__), array(), OPD_VERSION);
		wp_enqueue_script('opd', plugins_url('/js/admin.js', __FILE__), array(), OPD_VERSION);
		if (isset($_GET['page']) && in_array($_GET['page'], array('opd-add', 'opd-settings'))) {
			wp_enqueue_style('wp-color-picker');
			wp_enqueue_script('wp-color-picker');
			wp_enqueue_media();
		}
	}

	function front_init() {
		global $wpdb;
		if (isset($_GET['opd'])) {
			$download_key = $_GET["opd"];
			$download_key = preg_replace('/[^a-zA-Z0-9]/', '', $download_key);
			$download_details = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."sad_users WHERE secret_key = '".$download_key."' AND deleted = '0'", ARRAY_A);
			if (empty($download_details)) {
				header('Location: '.$this->options["expired_url"]);
				exit;
			}
			if ($download_details["registered"]+3600*intval($this->options['link_lifetime']) < time()) {
				header('Location: '.$this->options["expired_url"]);
				exit;
			}
			$wpdb->query("UPDATE ".$wpdb->prefix."sad_users SET downloads = downloads + 1 WHERE id = '".$download_details['id']."'");
			$this->download($download_details['source'], $download_details['url'], $this->options["expired_url"]);
		}
		add_action('wp_enqueue_scripts', array(&$this, 'front_enqueue_scripts'));
		add_action('wp_head', array(&$this, 'front_header'));
	}

	function front_enqueue_scripts() {
		wp_enqueue_script("jquery");
		wp_enqueue_script('opd', plugins_url('/js/opd.js', __FILE__), array(), OPD_VERSION, true);
		wp_enqueue_style('opd', plugins_url('/css/style.css', __FILE__), array(), OPD_VERSION);
	}

	static function install($_networkwide = null) {
		global $wpdb;
		if (function_exists('is_multisite') && is_multisite()) {
			if ($_networkwide) {
				$old_blog = $wpdb->blogid;
				$blog_ids = $wpdb->get_col('SELECT blog_id FROM '.esc_sql($wpdb->blogs));
				foreach ($blog_ids as $blog_id) {
					switch_to_blog($blog_id);
					self::activate();
				}
				switch_to_blog($old_blog);
				return;
			}
		}
		self::activate();
	}

	function install_new_blog($_blog_id, $_user_id, $_domain, $_path, $_site_id, $_meta) {
		if (is_plugin_active_for_network(basename(dirname(__FILE__)).'/' ).basename(__FILE__)) {
			switch_to_blog($_blog_id);
			self::activate();
			restore_current_blog();
		}
	}

	static function activate () {
		global $wpdb;
		$table_name = $wpdb->prefix."sad_files";
		if($wpdb->get_var("SHOW TABLES LIKE '".$table_name."'") != $table_name) {
			$sql = "CREATE TABLE ".$table_name." (
				id int(11) NOT NULL auto_increment,
				title varchar(255) collate utf8_unicode_ci NOT NULL,
				intro text collate utf8_unicode_ci NOT NULL,
				source varchar(32) collate latin1_general_cs NULL,
				filename varchar(255) collate utf8_unicode_ci NOT NULL,
				filename_string varchar(255) collate utf8_unicode_ci NOT NULL,
				options longtext collate utf8_unicode_ci NULL,
				registered int(11) NOT NULL,
				deleted int(11) NOT NULL default '0',
				UNIQUE KEY  id (id)
			);";
			$wpdb->query($sql);
		}
		if ($wpdb->get_var("SHOW COLUMNS FROM ".$wpdb->prefix."sad_files LIKE 'options'") != 'options') {
			$sql = "ALTER TABLE ".$wpdb->prefix."sad_files ADD options longtext collate utf8_unicode_ci NULL";
			$wpdb->query($sql);
		}
		$table_name = $wpdb->prefix."sad_users";
		if($wpdb->get_var("SHOW TABLES LIKE '".$table_name."'") != $table_name) {
			$sql = "CREATE TABLE ".$table_name." (
				id int(11) NULL auto_increment,
				file_id int(11) NOT NULL default '0',
				name varchar(255) collate utf8_unicode_ci NULL,
				email varchar(255) collate utf8_unicode_ci NULL,
				secret_key varchar(64) collate latin1_general_cs NULL,
				url varchar(255) collate utf8_unicode_ci NULL,
				source varchar(32) collate latin1_general_cs NULL,
				downloads int(11) NOT NULL default '0',
				registered int(11) NULL,
				deleted int(11) NOT NULL default '0',
				UNIQUE KEY  id (id)
			);";
			$wpdb->query($sql);
		}
		if ($wpdb->get_var("SHOW COLUMNS FROM ".$wpdb->prefix."sad_users LIKE 'file_id'") != 'file_id') {
			$sql = "ALTER TABLE ".$wpdb->prefix."sad_users ADD file_id int(11) NULL default '0'";
			$wpdb->query($sql);
		}
		if ($wpdb->get_var("SHOW COLUMNS FROM ".$wpdb->prefix."sad_users LIKE 'downloads'") != 'downloads') {
			$sql = "ALTER TABLE ".$wpdb->prefix."sad_users ADD downloads int(11) NULL default '0'";
			$wpdb->query($sql);
		}
		if ($wpdb->get_var("SHOW COLUMNS FROM ".$wpdb->prefix."sad_users LIKE 'secret_key'") != 'secret_key') {
			$sql = "ALTER TABLE ".$wpdb->prefix."sad_users ADD secret_key varchar(64) CHARACTER SET latin1 COLLATE latin1_general_cs NULL";
			$wpdb->query($sql);
		}
		if ($wpdb->get_var("SHOW COLUMNS FROM ".$wpdb->prefix."sad_users LIKE 'source'") != 'source') {
			$sql = "ALTER TABLE ".$wpdb->prefix."sad_users ADD source varchar(32) CHARACTER SET latin1 COLLATE latin1_general_cs NULL";
			$wpdb->query($sql);
		}
		$upload_dir = wp_upload_dir();
		if (!file_exists($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR)) {
			if (wp_mkdir_p($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR)) {
				if (!file_exists($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.'index.html')) {
					file_put_contents($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.'index.html', 'Silence is the gold!');
				}
				if (!file_exists($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.'.htaccess')) {
					file_put_contents($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.'.htaccess', 'deny from all');
				}
			}
		}
		update_option('opd_version', OPD_VERSION);
	}

	static function uninstall() {
		global $wpdb;
		if (function_exists('is_multisite') && is_multisite()) {
			$old_blog = $wpdb->blogid;
			$blog_ids = $wpdb->get_col('SELECT blog_id FROM '.esc_sql($wpdb->blogs));
			foreach ($blog_ids as $blog_id) {
				switch_to_blog($blog_id);
				self::deactivate(false);
			}
			switch_to_blog($old_blog);
		} else {
			self::deactivate(false);
		}
	}

	function uninstall_blog($_blog_id, $_drop) {
		if (is_plugin_active_for_network(basename(dirname(__FILE__)).'/'.basename(__FILE__)) && $_drop) {
			switch_to_blog($_blog_id);
			self::deactivate(true);
			restore_current_blog();
		}
	}
	
	static function deactivate($_force_delete = false) {
		global $wpdb;
		$clean_database = get_option('opd-clean-database', 'off');
		if ($clean_database == 'on' || $_force_delete) {
			$wpdb->query("DELETE FROM ".$wpdb->prefix."options WHERE option_name LIKE 'opd_%' AND option_name != 'opd-clean-database'");
			$wpdb->query("DROP TABLE IF EXISTS ".$wpdb->prefix."sad_files");
			$wpdb->query("DROP TABLE IF EXISTS ".$wpdb->prefix."sad_users");
		}
	}

	function get_options() {
		$exists = get_option('opd_version');
		if ($exists) {
			foreach ($this->options as $key => $value) {
				$this->options[$key] = get_option('opd_'.$key, $this->options[$key]);
			}
		}
	}

	function update_options() {
		//if (current_user_can('manage_options')) {
			foreach ($this->options as $key => $value) {
				update_option('opd_'.$key, $value);
			}
		//}
	}

	function admin_head() {
		echo '<script>var opd_ajax_handler = "'.admin_url('admin-ajax.php').'";</script>';
	}
	
	function admin_menu() {
		add_menu_page(
			__('Opt-In Downloads', 'opd')
			, __('Opt-In Downloads', 'opd')
			, 'manage_options'
			, 'opd'
			, array(&$this, 'admin_files')
		);
		add_submenu_page(
			'opd'
			, __('Files', 'opd')
			, __('Files', 'opd')
			, 'manage_options'
			, 'opd'
			, array(&$this, 'admin_files')
		);
		add_submenu_page(
			"opd"
			, __('Add File', 'opd')
			, __('Add File', 'opd')
			, "manage_options"
			, "opd-add"
			, array(&$this, 'admin_add_file')
		);
		add_submenu_page(
			'opd'
			, __('Log', 'opd')
			, __('Log', 'opd')
			, 'manage_options'
			, 'opd-users'
			, array(&$this, 'admin_users')
		);
		add_submenu_page(
			'opd'
			, __('Settings', 'opd')
			, __('Settings', 'opd')
			, 'manage_options'
			, 'opd-settings'
			, array(&$this, 'admin_settings')
		);
		if (defined('UAP_CORE')) {
			add_submenu_page(
				"opd"
				, __('How To Use', 'opd')
				, __('How To Use', 'opd')
				, "manage_options"
				, "opd-using"
				, array(&$this, 'admin_using')
			);
		} else {
			add_submenu_page(
				'opd'
				, __('FAQ', 'opd')
				, __('FAQ', 'opd')
				, 'manage_options'
				, 'opd-faq'
				, array(&$this, 'admin_faq')
			);
		}
	}

	function admin_settings() {
		global $wpdb;
		$message = "";
		echo '
		<div class="wrap admin_opd_wrap">
			<h2>'.__('Opt-In Downloads - Settings', 'opd').'</h2>
			<form class="opd-form" enctype="multipart/form-data" method="post" style="margin: 0px" action="'.admin_url('admin.php').'">
			<div class="postbox-container" style="width: 100%;">
				<h2 id="opd-settings-tabs" class="opd-tabs">
					<a class="opd-tab opd-tab-active" href="#opd-general">'.__('General', 'opd').'</a>
					<a class="opd-tab" href="#opd-mailing">'.__('Mailing', 'opd').'</a>
					<a class="opd-tab" href="#opd-integrations">'.__('Integrations', 'opd').'</a>
				</h2>				
				<div id="opd-general" class="opd-settings-tab metabox-holder" style="display: block;">
					<div class="meta-box-sortables ui-sortable">
						<div class="postbox opd_postbox">
							<!--<div class="handlediv" title="Click to toggle"><br></div>-->
							<h3 class="hndle" style="cursor: default;"><span>'.__('General Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Intro', 'opd').':</th>
										<td>
											<textarea class="widefat" id="opd_intro" name="opd_intro" style="height: 120px;">'.esc_html($this->options['intro']).'</textarea><br />
											<em>'.__('Please enter content of opt-in box. HTML allowed. Opt-in form is inserted below this content. You can override this content for each file.', 'opd').'</em>
										</td>
									</tr> 
									<tr>
										<th>'.__('"Name" field placeholder', 'opd').':</th>
										<td>
											<input type="text" id="opd_placeholder_name" name="opd_placeholder_name" value="'.esc_html($this->options['placeholder_name']).'" class="widefat">
											<br /><em>'.__('Enter the placeholder for "Name" input field.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Disable "name" field', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_disable_name" name="opd_disable_name" '.($this->options['disable_name'] == "on" ? 'checked="checked"' : '').'"> '.__('Disable "Name" field in opt-in form', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to disable "Name" field in opt-in form.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('"E-mail" field placeholder', 'opd').':</th>
										<td>
											<input type="text" id="opd_placeholder_email" name="opd_placeholder_email" value="'.esc_html($this->options['placeholder_email']).'" class="widefat">
											<br /><em>'.__('Enter the placeholder for "E-mail" input field.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Extended e-mail validation', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_email_validation" name="opd_email_validation" '.($this->options['email_validation'] == "on" ? 'checked="checked"' : '').'"> '.__('Enable extended e-mail address validation', 'opd').'
											<br /><em>'.__('If you turn this option on, the plugin will check MX records according to the host provided within the email address. PHP 5 >= 5.3 required!', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('"Subscribe" button label', 'opd').':</th>
										<td>
											<input type="text" id="opd_button_label" name="opd_button_label" value="'.esc_html($this->options['button_label']).'" class="widefat">
											<br /><em>'.__('Enter the label for "Subscribe" button.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Enable GDPR', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_gdpr_enable" name="opd_gdpr_enable" '.($this->options['gdpr_enable'] == "on" ? 'checked="checked"' : '').'" onclick="opd_switch_gdpr();"> '.__('Enable checkbox to agree with the Terms & Conditions', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to add checkbox to subscription form.', 'opd').'</em>
										</td>
									</tr>
									<tr class="opd-gdpr-depend"'.($this->options['gdpr_enable'] == "on" ? ' style="display:table-row;"' : '').'>
										<th>'.__('GDPR title', 'opd').':</th>
										<td>
											<input type="text" id="opd_gdpr_title" name="opd_gdpr_title" value="'.esc_html($this->options['gdpr_title']).'" class="widefat">
											<br /><em>'.__('Enter the label for GDPR checkbox. Wrap your keyword with "{" and "}" to link it with Terms & Conditions box. HTML allowed.', 'opd').'</em>
										</td>
									</tr>
									<tr class="opd-gdpr-depend"'.($this->options['gdpr_enable'] == "on" ? ' style="display:table-row;"' : '').'>
										<th>'.__('Terms & Conditions', 'opd').':</th>
										<td>
											<textarea id="opd_terms" name="opd_terms" class="widefat" style="height: 120px;">'.esc_html($this->options['terms']).'</textarea>
											<br /><em>'.__('Drop your Terms & Conditions text here.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Thanksgiving message', 'opd').':</th>
										<td><input type="text" id="opd_thanks_message" name="opd_thanks_message" value="'.esc_html($this->options['thanks_message']).'" class="widefat"><br /><em>'.__('This message appears in case of successful form submission.', 'opd').'</em></td>
									</tr>
									<tr>
										<th>'.__('Google Analytics tracking', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_ga_tracking" name="opd_ga_tracking" '.($this->options['ga_tracking'] == "on" ? 'checked="checked"' : '').'"> '.__('Enable Google Analytics tracking', 'opd').'
											<br /><em>'.__('Send subscribtion event to Google Analytics. Google Analytics must be installed on your website.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('CSV column separator', 'opd').':</th>
										<td>
											<select id="opd-csv_separator" name="opd_csv_separator">
												<option value=";"'.($this->options['csv_separator'] == ';' ? ' selected="selected"' : '').'>'.__('Semicolon - ";"', 'opd').'</option>
												<option value=","'.($this->options['csv_separator'] == ',' ? ' selected="selected"' : '').'>'.__('Comma - ","', 'opd').'</option>
												<option value="tab"'.($this->options['csv_separator'] == 'tab' ? ' selected="selected"' : '').'>'.__('Tab', 'opd').'</option>
											</select>
											<br /><em>'.__('Please select CSV column separator.', 'opd').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox" id="opd-downloads">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Download Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Temporary link lifetime', 'opd').':</th>
										<td style="vertical-align: middle;">
											<input type="text" id="opd_link_lifetime" name="opd_link_lifetime" value="'.htmlspecialchars($this->options['link_lifetime'], ENT_QUOTES).'" style="width: 60px; text-align: right;"> '.__('hours', 'opd').'
											<br /><em>'.__('Original download links will be replaced by temporary download links. Please enter period of download link validity.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Expired link redirection URL', 'opd').':</th>
										<td style="vertical-align: middle;">
											<input type="text" name="opd_expired_url" value="'.esc_html($this->options['expired_url']).'" class="widefat" placeholder="'.__('Expired link redirection URL', 'opd').'">
											<br /><em>'.__('Please enter the destination URL for expired links.', 'opd').'</em>
										</td>
									</tr>
									<tr><td colspan="2"><hr></td></tr>';
		if (!defined('UAP_CORE')) {
			echo '
									<tr>
										<th>'.__('Secure download', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_media_secure" name="opd_media_secure" '.($this->options['media_secure'] == "on" ? 'checked="checked"' : '').'"> '.__('Secure download of Media Library files', 'opd').'
											<br /><em>'.__('Enable secure download of Media Library files. Users can not see the real location of the file.', 'opd').'</em>
										</td>
									</tr>';
		}
		echo '
									<tr>
										<th>'.__('Enable X-Sendfile', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_xsendfile" name="opd_xsendfile" '.($this->options['xsendfile'] == "on" ? 'checked="checked"' : '').'"> '.__('Download Media Library files through X-Sendfile module', 'opd').'
											<br /><em>'.__('Use this option to enable X-SendFile mode to download huge Media Library files securely. Please contact your hosting provider to make sure that <a href="https://tn123.org/mod_xsendfile/" target="_blank"><strong>mod_xsendfile</strong></a> module installed on your server. Do not activate this option if <strong>mod_xsendfile</strong> module is not installed.', 'opd').'</em>
										</td>
									</tr>
									<tr id="opd-amazon-s3"><td colspan="2"><hr></td></tr>
									<tr>
										<th>'.__('Amazon Access Key', 'opd').':</th>
										<td style="vertical-align: middle;">
											<input type="text" name="opd_amazon_access_key" value="'.esc_html($this->options['amazon_access_key']).'" class="widefat" placeholder="'.__('Amazon Access Key', 'opd').'">
											<br /><em>'.__('Please enter Amazon Access Key. Ignore it, if you do not host files on Amazon S3.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Amazon Secret Key', 'opd').':</th>
										<td style="vertical-align: middle;">
											<input type="text" name="opd_amazon_secret_key" value="'.esc_html($this->options['amazon_secret_key']).'" class="widefat" placeholder="'.__('Amazon Secret Key', 'opd').'">
											<br /><em>'.__('Please enter Amazon Secret Key. Ignore it, if you do not host files on Amazon S3.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Amazon S3 Bucket', 'opd').':</th>
										<td style="vertical-align: middle;">
											<input type="text" name="opd_amazon_bucket" value="'.esc_html($this->options['amazon_bucket']).'" class="widefat" placeholder="'.__('Amazon S3 Bucket', 'opd').'">
											<br /><em>'.__('Please enter Amazon S3 Bucket. Ignore it, if you do not host files on Amazon S3.', 'opd').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Design Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Box background color', 'opd').':</th>
										<td>
											<input type="text" class="opd-color ic_input_number" name="opd_box_color" value="'.esc_html($this->options['box_color']).'" placeholder=""> 
											<em>'.__('Set main box background color. Leave empty for transparent background.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Box border color', 'opd').':</th>
										<td>
											<input type="text" class="opd-color ic_input_number" name="opd_box_border_color" value="'.esc_html($this->options['box_border_color']).'" placeholder=""> 
											<em>'.__('Set main box border color. Leave empty for transparent border.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Font color', 'opd').':</th>
										<td>
											<input type="text" class="opd-color ic_input_number" name="opd_box_font_color" value="'.esc_html($this->options['box_font_color']).'" placeholder="">
											<em>'.__('Set font color. Leave empty for default font color.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Font size', 'opd').':</th>
										<td style="vertical-align: middle;">
											<input type="text" class="ic_input_number" name="opd_box_font_size" value="'.esc_html($this->options['box_font_size']).'" placeholder="pixels"> '.__('pixels', 'opd').'
											<br /><em>'.__('Set font size (pixels).', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field border color', 'opd').':</th>
										<td>
											<input type="text" class="opd-color ic_input_number" name="opd_input_border_color" value="'.esc_html($this->options['input_border_color']).'" placeholder="">
											<em>'.__('Set border color of "Name" and "E-mail" input fields.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field background color', 'opd').':</th>
										<td>
											<input type="text" class="opd-color ic_input_number" name="opd_input_background_color" value="'.esc_html($this->options['input_background_color']).'" placeholder="">
											<em>'.__('Set background color of "Name" and "E-mail" input fields.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field background opacity', 'opd').':</th>
										<td>
											<input type="text" class="ic_input_number" name="opd_input_background_opacity" value="'.esc_html($this->options['input_background_opacity']).'" placeholder="[0...1]">
											<br /><em>'.__('Set background opacity of "Name" and "E-mail" input fields. The value must be in a range [0...1].', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field font color', 'opd').':</th>
										<td>
											<input type="text" class="opd-color ic_input_number" name="opd_input_font_color" value="'.esc_html($this->options['input_font_color']).'" placeholder="">
											<em>'.__('Set font color of "Name" and "E-mail" input fields.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field font size', 'opd').':</th>
										<td style="vertical-align: middle;">
											<input type="text" class="ic_input_number" name="opd_input_font_size" value="'.esc_html($this->options['input_font_size']).'" placeholder="pixels"> '.__('pixels', 'opd').'
											<br /><em>'.__('Set font size (pixels) of "Name" and "E-mail" input fields.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Button color', 'opd').':</th>
										<td>
											<input type="text" class="opd-color ic_input_number" name="opd_button_color" value="'.esc_html($this->options['button_color']).'" placeholder=""> 
											<em>'.__('Set button color.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Button font color', 'opd').':</th>
										<td>
											<input type="text" class="opd-color ic_input_number" name="opd_button_font_color" value="'.esc_html($this->options['button_font_color']).'" placeholder="">
											<em>'.__('Set button font color.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Button font size', 'opd').':</th>
										<td style="vertical-align: middle;">
											<input type="text" class="ic_input_number" name="opd_button_font_size" value="'.esc_html($this->options['button_font_size']).'" placeholder="pixels"> '.__('pixels', 'opd').'
											<br /><em>'.__('Set font size (pixels) of the button.', 'opd').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
					</div>
				</div>
				<div id="opd-mailing" class="opd-settings-tab metabox-holder" style="display: none;">
					<div class="meta-box-sortables ui-sortable">
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('General Mailing Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Sender name', 'opd').':</th>
										<td><input type="text" id="opd_from_name" name="opd_from_name" value="'.esc_html($this->options['from_name']).'" class="widefat"><br /><em>'.__('Please enter sender name. All messages are sent using this name as "FROM:" header value.', 'opd').'</em></td>
									</tr>
									<tr>
										<th>'.__('Sender e-mail', 'opd').':</th>
										<td><input type="text" id="opd_from_email" name="opd_from_email" value="'.esc_html($this->options['from_email']).'" class="widefat"><br /><em>'.__('Please enter sender e-mail. All messages are sent using this e-mail as "FROM:" header value.', 'opd').'</em></td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Welcome Message Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_thanksgiving_enable" name="opd_thanksgiving_enable" '.($this->options['thanksgiving_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Send welcome message', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to send welcome message to subscriber.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Subject', 'opd').':</th>
										<td>
											<input type="text" id="opd_thanksgiving_email_subject" name="opd_thanksgiving_email_subject" value="'.esc_html($this->options['thanksgiving_email_subject']).'" class="widefat">
											<br /><em>'.__('In case of successful subscription, your visitors receive e-mail message which contains download link. This is the subject field of the message.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Message', 'opd').':</th>
										<td>
											<textarea id="opd_thanksgiving_email_body" name="opd_thanksgiving_email_body" class="widefat" style="height: 120px;">'.esc_html($this->options['thanksgiving_email_body']).'</textarea>
											<br /><em>'.__('This e-mail message is sent to your visitor in case of successful subscription. You can use the following keywords: {download_link}, {name}, {e-mail}.', 'opd').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Admin Notification Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_mail_enable" name="opd_mail_enable" '.($this->options['mail_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Send details to admin', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to receive submitted contact details by e-mail.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Admin e-mail address', 'opd').':</th>
										<td>
											<input type="text" id="opd_mail_email" name="opd_mail_email" value="'.esc_html($this->options['mail_email']).'" class="widefat">
											<br /><em>'.__('Enter your e-mail address. Submitted contact details will be sent to this e-mail address. You can set several comma-separated e-mails.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Subject', 'opd').':</th>
										<td>
											<input type="text" id="opd_mail_subject" name="opd_mail_subject" value="'.esc_html($this->options['mail_subject']).'" class="widefat">
											<br /><em>'.__('In case of successful subscription, administrator may receive notification message. This is subject field of the message.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Message', 'opd').':</th>
										<td>
											<textarea id="opd_mail_message" name="opd_mail_message" class="widefat" style="height: 120px;">'.esc_html($this->options['mail_message']).'</textarea>
											<br /><em>'.__('This notification is sent to administrator in case of successful subscription. You can use the shortcodes the following shortcodes: {email}, {name}, {ip}, {url}, {user-agent}.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('"FROM" header', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_mail_from" name="opd_mail_from" '.($this->options['mail_from'] == "on" ? 'checked="checked"' : '').'"> '.__("Put user's e-mail into FROM header (not recommended)", 'opd').'
											<br /><em>'.__('Please remember, many hosting providers do not allow to send e-mails with 3rd party FROM header.', 'opd').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
					</div>
				</div>
				<div id="opd-integrations" class="opd-settings-tab metabox-holder" style="display: none;">
					<div class="meta-box-sortables ui-sortable">
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('MailChimp Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable MailChimp', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_mailchimp_enable" name="opd_mailchimp_enable" '.($this->options['mailchimp_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to MailChimp', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to MailChimp.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Key', 'opd').':</th>
										<td>
											<input type="text" id="opd_mailchimp_api_key" name="opd_mailchimp_api_key" value="'.esc_html($this->options['mailchimp_api_key']).'" class="widefat">
											<br /><em>'.__('Enter your MailChimp API Key. You can get it <a href="https://admin.mailchimp.com/account/api-key-popup" target="_blank">here</a>.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'opd').':</th>
										<td>
											<input type="text" id="opd-mailchimp-list" name="opd_mailchimp_list" value="'.esc_html($this->options['mailchimp_list']).'" class="opd-input-options opd-input" readonly="readonly" onfocus="opd_mailchimp_lists_focus(this);" onblur="opd_input_options_blur(this);" />
											<input type="hidden" id="opd-mailchimp-list-id" name="opd_mailchimp_list_id" value="'.esc_html($this->options['mailchimp_list_id']).'" />
											<div id="opd-mailchimp-list-items" class="opd-options-list">
												<div class="opd-options-list-data"></div>
												<div class="opd-options-list-spinner"><i class="opd-fa opd-fa-spinner opd-fa-spin"></i></div>
											</div>
											<br /><em>'.__('Enter your List ID.', 'opd').'</em>
											<script>
												function opd_mailchimp_lists_focus(object) {
													opd_input_options_focus(object, {"action": "opd-mailchimp-lists", "opd_api_key": jQuery("#opd_mailchimp_api_key").val()});
												}
											</script>
										</td>
									</tr>
									<tr>
										<th>'.__('Double opt-in', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_mailchimp_double" name="opd_mailchimp_double" '.($this->options['mailchimp_double'] == "on" ? 'checked="checked"' : '').'"> '.__('Ask users to confirm their subscription', 'opd').'
											<br /><em>'.__('Control whether a double opt-in confirmation message is sent.', 'opd').'</em>
										</td>
									</tr>
								
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('iContact Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable iContact', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_icontact_enable" name="opd_icontact_enable" '.($this->options['icontact_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to iContact', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to iContact.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('AppID', 'opd').':</th>
										<td>
											<input type="text" id="opd_icontact_appid" name="opd_icontact_appid" value="'.esc_html($this->options['icontact_appid']).'" class="widefat opd-input" onchange="opd_icontact_handler();">
											<br /><em>'.__('Obtained when you <a href="http://developer.icontact.com/documentation/register-your-app/" target="_blank">Register the API application</a>. This identifier is used to uniquely identify your application.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Username', 'opd').':</th>
										<td>
											<input type="text" id="opd_icontact_apiusername" name="opd_icontact_apiusername" value="'.esc_html($this->options['icontact_apiusername']).'" class="widefat opd-input" onchange="opd_icontact_handler();">
											<br /><em>'.__('The iContact username for logging into your iContact account.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Password', 'opd').':</th>
										<td>
											<input type="text" id="opd_icontact_apipassword" name="opd_icontact_apipassword" value="'.esc_html($this->options['icontact_apipassword']).'" class="widefat opd-input" onchange="opd_icontact_handler();">
											<br /><em>'.__('The API application password set when the application was registered. This API password is used as input when your application authenticates to the API. This password is not the same as the password you use to log in to iContact.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'opd').':</th>
										<td>
											<input type="text" id="opd_icontact_listid" name="opd_icontact_listid" value="'.esc_html($this->options['icontact_listid']).'" class="widefat opd-input">
											<br /><em>'.sprintf(__('Enter your List ID. You can get List ID from %sthis table%s.', 'opd'),'<a data-param1="'.esc_html($this->options['icontact_appid']).'" data-param2="'.esc_html($this->options['icontact_apiusername']).'" data-param3="'.esc_html($this->options['icontact_apipassword']).'" data-title="'.__('Available Lists', 'opd').'" data-subtitle="'.__('iContact', 'opd').'" data-action="opd-icontact-lists" href="#" id="opd-icontact-lists" title="'.__('Available Lists', 'opd').'" onclick="return opd_admin_popup_open(this);">', '</a>').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('GetResponse Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable GetResponse', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_getresponse_enable" name="opd_getresponse_enable" '.($this->options['getresponse_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to GetResponse', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to GetResponse.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Key', 'opd').':</th>
										<td>
											<input type="text" id="opd_getresponse_api_key" name="opd_getresponse_api_key" value="'.esc_html($this->options['getresponse_api_key']).'" class="widefat opd-input" onchange="opd_getresponse_handler();">
											<br /><em>'.__('Enter your GetResponse API Key. You can get your API Key <a href="https://app.getresponse.com/api" target="_blank">here</a>.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Campaign ID', 'opd').':</th>
										<td>
											<input type="text" id="opd-getresponse-list" name="opd_getresponse_list" value="'.esc_html($this->options['getresponse_list']).'" class="opd-input-options opd-input" readonly="readonly" onfocus="opd_getresponse_lists_focus(this);" onblur="opd_input_options_blur(this);" />
											<input type="hidden" id="opd-getresponse-list-id" name="opd_getresponse_list_id" value="'.esc_html($this->options['getresponse_list_id']).'" />
											<div id="opd-getresponse-list-items" class="opd-options-list">
												<div class="opd-options-list-data"></div>
												<div class="opd-options-list-spinner"><i class="opd-fa opd-fa-spinner opd-fa-spin"></i></div>
											</div>
											<br /><em>'.__('Enter your Campaign ID.', 'opd').'</em>
											<script>
												function opd_getresponse_lists_focus(object) {
													opd_input_options_focus(object, {"action": "opd-getresponse-lists", "opd_api_key": jQuery("#opd_getresponse_api_key").val()});
												}
											</script>
										</td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Campaign Monitor Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable Campaign Monitor', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_campaignmonitor_enable" name="opd_campaignmonitor_enable" '.($this->options['campaignmonitor_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to Campaign Monitor', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to Campaign Monitor. <strong>CURL required!</strong>', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Key', 'opd').':</th>
										<td>
											<input type="text" id="opd_campaignmonitor_api_key" name="opd_campaignmonitor_api_key" value="'.esc_html($this->options['campaignmonitor_api_key']).'" class="widefat">
											<br /><em>'.__('Enter your Campaign Monitor API Key. You can get your API Key from the Account Settings page when logged into your Campaign Monitor account.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'opd').':</th>
										<td>
											<input type="text" id="opd_campaignmonitor_list_id" name="opd_campaignmonitor_list_id" value="'.esc_html($this->options['campaignmonitor_list_id']).'" class="widefat">
											<br /><em>'.__('Enter your List ID. You can get List ID from the list editor page when logged into your Campaign Monitor account.', 'opd').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Mad Mimi Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable Mad Mimi', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_madmimi_enable" name="opd_madmimi_enable" '.($this->options['madmimi_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to Mad Mimi', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to Mad Mimi.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Username/E-mail', 'opd').':</th>
										<td>
											<input type="text" id="opd_madmimi_login" name="opd_madmimi_login" value="'.esc_html($this->options['madmimi_login']).'" class="widefat opd-input" onchange="opd_madmimi_handler();">
											<br /><em>'.__('Enter your Mad Mimi username/e-mail.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Key', 'opd').':</th>
										<td>
											<input type="text" id="opd_madmimi_api_key" name="opd_madmimi_api_key" value="'.esc_html($this->options['madmimi_api_key']).'" class="widefat opd-input" onchange="opd_madmimi_handler();">
											<br /><em>'.__('Enter your Mad Mimi API Key. You can get your API Key <a href="https://madmimi.com/user/edit?account_info_tabs=account_info_personal" target="_blank">here</a>.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'opd').':</th>
										<td>
											<input type="text" id="opd_madmimi_list_id" name="opd_madmimi_list_id" value="'.esc_html($this->options['madmimi_list_id']).'" class="widefat opd-input">
											<br /><em>'.sprintf(__('Enter your List ID. You can get List ID from %sthis table%s.', 'opd'),'<a data-param1="'.esc_html($this->options['madmimi_login']).'" data-param2="'.esc_html($this->options['madmimi_api_key']).'" data-param3="" data-title="'.__('Available Lists', 'opd').'" data-subtitle="'.__('Mad Mimi', 'opd').'" data-action="opd-madmimi-lists" href="#" id="opd-madmimi-lists" title="'.__('Available Lists', 'opd').'" onclick="return opd_admin_popup_open(this);">', '</a>').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Sendy Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable Sendy', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_sendy_enable" name="opd_sendy_enable" '.($this->options['sendy_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to Sendy', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to Sendy.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Installation URL', 'opd').':</th>
										<td>
											<input type="text" id="opd_sendy_url" name="opd_sendy_url" value="'.esc_html($this->options['sendy_url']).'" class="widefat">
											<br /><em>'.__('Enter your Sendy installation URL (without the trailing slash).', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'opd').':</th>
										<td>
											<input type="text" id="opd_sendy_listid" name="opd_sendy_listid" value="'.esc_html($this->options['sendy_listid']).'" class="widefat">
											<br /><em>'.__('Enter your List ID. This encrypted & hashed id can be found under View all lists section named ID.', 'opd').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Benchmark Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable Benchmark', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_benchmark_enable" name="opd_benchmark_enable" '.($this->options['benchmark_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to Benchmark Email', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to Benchmark Email.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Key', 'opd').':</th>
										<td>
											<input type="text" id="opd_benchmark_api_key" name="opd_benchmark_api_key" value="'.esc_html($this->options['benchmark_api_key']).'" class="widefat" onchange="opd_benchmark_handler();">
											<br /><em>'.__('Enter your Benchmark Email API Key. You can get your API Key <a href="https://ui.benchmarkemail.com/EditSetting" target="_blank">here</a>.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'opd').':</th>
										<td>
											<input type="text" id="opd_benchmark_list_id" name="opd_benchmark_list_id" value="'.esc_html($this->options['benchmark_list_id']).'" class="widefat">
											<br /><em>'.sprintf(__('Enter your List ID. You can get List ID from %sthis table%s.', 'opd'),'<a data-param1="'.esc_html($this->options['benchmark_api_key']).'" data-param2="" data-param3="" data-title="'.__('Available Lists', 'opd').'" data-subtitle="'.__('Mad Mimi', 'opd').'" data-action="opd-benchmark-lists" href="#" id="opd-benchmark-lists" title="'.__('Available Lists', 'opd').'" onclick="return opd_admin_popup_open(this);">', '</a>').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Double opt-in', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_benchmark_double" name="opd_benchmark_double" '.($this->options['benchmark_double'] == "on" ? 'checked="checked"' : '').'"> '.__('Ask users to confirm their subscription', 'opd').'
											<br /><em>'.__('Control whether a double opt-in confirmation message is sent.', 'opd').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('AWeber Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Enable AWeber', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_aweber_enable" name="opd_aweber_enable" '.($this->options['aweber_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to AWeber', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to AWeber.', 'opd').'</em>
										</td>
									</tr>';
		$account = null;
		if ($this->options['aweber_access_secret']) {
			if (!class_exists('AWeberAPI')) {
				require_once(dirname(__FILE__).'/aweber_api/aweber_api.php');
			}
			try {
				$aweber = new AWeberAPI($this->options['aweber_consumer_key'], $this->options['aweber_consumer_secret']);
				$account = $aweber->getAccount($this->options['aweber_access_key'], $this->options['aweber_access_secret']);
			} catch (AWeberException $e) {
				$account = null;
			}
		}
		if (!$account) {
			echo '
									<tbody id="opd-aweber-group">
										<tr>
											<th>'.__('Authorization code', 'opd').':</th>
											<td>
												<input type="text" id="opd_aweber_oauth_id" value="" class="widefat opd-input" placeholder="AWeber authorization code">
												<br /><em>Get your authorization code <a target="_blank" href="https://auth.aweber.com/1.0/oauth/authorize_app/'.OPD_AWEBER_APPID.'">'.__('here', 'opd').'</a></em>.
											</td>
										</tr>
										<tr>
											<th></th>
											<td style="vertical-align: middle;">
												<a class="opd-button opd-button-small" onclick="return opd_aweber_connect(this);"><i class="opd-fa opd-fa-ok"></i><label>Connect</label></a>
											</td>
										</tr>
									</tbody>';
		} else {
			echo '
									<tbody id="opd-aweber-group">
										<tr>
											<th>'.__('Connected', 'opd').':</th>
											<td>
												<a class="opd-button opd-button-small" onclick="return opd_aweber_disconnect(this);"><i class="opd-fa opd-fa-ok"></i><label>Disconnect</label></a>
												<br /><em>'.__('Click the button to disconnect.', 'opd').'</em>
											</td>
										</tr>
										<tr>
											<th>'.__('List ID', 'opd').':</th>
											<td>
												<select name="opd_aweber_listid" style="width: 40%;">
													<option value="">'.__('--- Select List ID ---', 'opd').'</option>';
				$lists = $account->lists;
				foreach ($lists as $list) {
					echo '
													<option value="'.$list->id.'"'.($list->id == $this->options['aweber_listid'] ? ' selected="selected"' : '').'>'.$list->name.'</option>';
				}
				echo '
												</select>
												<br /><em>'.__('Select your List ID.', 'opd').'</em>
											</td>
										</tr>
									</tbody>';
		}
		echo '
								</table>
							</div>
						</div>';
						
		if (function_exists('mailster')) {
			echo '
						<div class="postbox opd_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Mailster Settings', 'opd').'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">';
			$lists = mailster('lists')->get();
			if (sizeof($lists) == 0) {
				echo '
									<tr>
										<th>'.__('Enable Mailster', 'opd').':</th>
										<td>'.__('Please', 'opd').' <a href="edit.php?post_type=newsletter&page=mailster_lists">'.__('create', 'opd').'</a> '.__('at least one list.', 'opd').'</td>
									</tr>';
			} else {
				echo '
									<tr>
										<th>'.__('Enable Mailster', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_mymail_enable" name="opd_mymail_enable" '.($this->options['mymail_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to Mailster', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to Mailster.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'opd').':</th>
										<td>
											<select name="opd_mymail_listid" class="ic_input_m">';
				foreach ($lists as $list) {
					echo '
												<option value="'.esc_html($list->ID).'"'.($list->ID == $this->options['mymail_listid'] ? ' selected="selected"' : '').'>'.$list->name.'</option>';
				}
				echo '
											</select>
											<br /><em>'.__('Select your List ID.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Double Opt-In', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd_mymail_double" name="opd_mymail_double" '.($this->options['mymail_double'] == "on" ? 'checked="checked"' : '').'"> '.__('Enable Double Opt-In', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to enable double opt-in feature.', 'opd').'</em>
										</td>
									</tr>';
			}
			echo '
								</table>
							</div>
						</div>';
		}
		echo '
					</div>
				</div>
				<hr>
				<div class="opd-button-container">
					<input type="hidden" name="action" value="opd-save-settings" />
					<input type="hidden" name="opd_version" value="'.OPD_VERSION.'" />
					<a class="opd-button" onclick="return opd_save_settings(this);"><i class="opd-fa opd-fa-ok"></i><label>'.__('Save Settings', 'opd').'</label></a>
				</div>
				<div class="opd-message"></div>
			</div>
			</form>
			<div class="opd-admin-popup-overlay" id="opd-admin-popup-overlay"></div>
			<div class="opd-admin-popup" id="opd-admin-popup">
				<div class="opd-admin-popup-inner">
					<div class="opd-admin-popup-title">
						<a href="#" title="'.esc_html__('Close', 'opd').'" onclick="return opd_admin_popup_close();"><i class="opd-fa opd-fa-cancel"></i></a>
						<h3><label></label><span></span></h3>
					</div>
					<div class="opd-admin-popup-content">
						<div class="opd-admin-popup-content-form">
						</div>
					</div>
					<div class="opd-admin-popup-loading"><i class="opd-fa opd-fa-spinner opd-fa-spin"></i></div>
				</div>
			</div>
			<div id="opd-global-message"></div>
			<script type="text/javascript">
				function opd_getresponse_handler() {
					jQuery("#opd-getresponse-lists").attr("data-param1", jQuery("#opd_getresponse_api_key").val());
				}
				function opd_icontact_handler() {
					jQuery("#opd-icontact-lists").attr("data-param1", jQuery("#opd_icontact_appid").val());
					jQuery("#opd-icontact-lists").attr("data-param2", jQuery("#opd_icontact_apiusername").val());
					jQuery("#opd-icontact-lists").attr("data-param3", jQuery("#opd_icontact_apipassword").val());
				}
				function opd_madmimi_handler() {
					jQuery("#opd-madmimi-lists").attr("data-param1", jQuery("#opd_madmimi_login").val());
					jQuery("#opd-madmimi-lists").attr("data-param2", jQuery("#opd_madmimi_api_key").val());
				}
				function opd_benchmark_handler() {
					jQuery("#opd-benchmark-lists").attr("data-param1", jQuery("#opd_benchmark_api_key").val());
				}
				jQuery(document).ready(function(){
					jQuery(".opd-color").wpColorPicker();
				});
				jQuery("#opd-tabs a").click(function(){
					if (jQuery(this).hasClass("opd-nav-tab-active")) {
					} else {
						var active_tab = jQuery(".opd-nav-tab-active").attr("href");
						jQuery(".opd-nav-tab-active").removeClass("nav-tab-active");
						jQuery(".opd-nav-tab-active").removeClass("opd-nav-tab-active");
						var tab = jQuery(this).attr("href");
						jQuery(this).addClass("nav-tab-active");
						jQuery(this).addClass("opd-nav-tab-active");
						jQuery(active_tab).fadeOut(300, function(){
							jQuery(tab).fadeIn(300);
						});
					}
					return false;
				});
			</script>			
		</div>';
	}

	function admin_madmimi_lists() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			$callback = '';
			$html = '';
			if (isset($_REQUEST['callback'])) {
				header("Content-type: text/javascript");
				$callback = preg_replace('/[^a-zA-Z0-9_]/', '', $_REQUEST['callback']);
			}
			$id = null;
			if (!array_key_exists('param1', $_REQUEST) || empty($_REQUEST['param1']) || !array_key_exists('param2', $_REQUEST) || empty($_REQUEST['param2'])) {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('Invalid API credentials.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}

			$lists = $this->madmimi_getlists($_REQUEST['param1'], $_REQUEST['param2']);
			if (!empty($lists)) {
				$html .= '
	<table class="opd-admin-popup-table">
		<tr>
			<th>'.__('List ID', 'opd').'</th>
			<th>'.__('List Name', 'opd').'</th>
		</tr>';
				foreach ($lists as $key => $value) {
					$html .= '
		<tr>
			<td>'.esc_html($key).'</td>
			<td>'.esc_html($value).'</td>
		</tr>';
				}
				$html .= '
	</table>';
			} else {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('No data found.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}
			
			$return_data = array(
				'status' => 'OK',
				'html' => $html
			);
			if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
			else echo json_encode($return_data);
		}
		exit;
	}

	function admin_benchmark_lists() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			$callback = '';
			$html = '';
			if (isset($_REQUEST['callback'])) {
				header("Content-type: text/javascript");
				$callback = preg_replace('/[^a-zA-Z0-9_]/', '', $_REQUEST['callback']);
			}
			$id = null;
			if (!array_key_exists('param1', $_REQUEST) || empty($_REQUEST['param1'])) {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('Invalid API credentials.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}

			$lists = $this->benchmark_getlists($_REQUEST['param1']);
			if (!empty($lists)) {
				$html .= '
	<table class="opd-admin-popup-table">
		<tr>
			<th>'.__('List ID', 'opd').'</th>
			<th>'.__('List Name', 'opd').'</th>
		</tr>';
				foreach ($lists as $key => $value) {
					$html .= '
		<tr>
			<td>'.esc_html($key).'</td>
			<td>'.esc_html($value).'</td>
		</tr>';
				}
				$html .= '
	</table>';
			} else {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('No data found.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}
			
			$return_data = array(
				'status' => 'OK',
				'html' => $html
			);
			if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
			else echo json_encode($return_data);
		}
		exit;
	}

	function admin_getresponse_lists() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			$callback = '';
			$html = '';
			if (isset($_REQUEST['callback'])) {
				header("Content-type: text/javascript");
				$callback = preg_replace('/[^a-zA-Z0-9_]/', '', $_REQUEST['callback']);
			}
			$id = null;
			if (!array_key_exists('param1', $_REQUEST) || empty($_REQUEST['param1'])) {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('Invalid API credentials.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}

			$request = json_encode(
				array(
					'method' => 'get_campaigns',
					'params' => array(
						$_REQUEST['param1']
					),
					'id' => ''
				)
			);

			$curl = curl_init('https://api2.getresponse.com/');
			curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
			$header = array(
				'Content-Type: application/json',
				'Content-Length: '.strlen($request)
			);
			curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
			curl_setopt($curl, CURLOPT_TIMEOUT, 10);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
			curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
			curl_setopt($curl, CURLOPT_HEADER, 0);								
			$response = curl_exec($curl);
			if (curl_error($curl)) {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('API call failed.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}
			$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
			if ($httpCode != '200') {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('API call failed.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}
			curl_close($curl);
			$post = json_decode($response, true);
			if(!empty($post['error'])) {
				$return_data = array(
					'status' => 'ERROR',
					'message' => sprintf(__('API call failed: %s', 'opd'), $post['error']['message'])
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}
			if (!empty($post['result'])) {
				$html .= '
	<table class="opd-admin-popup-table">
		<tr>
			<th>'.__('Campaign ID', 'opd').'</th>
			<th>'.__('Campaign Name', 'opd').'</th>
		</tr>';
				foreach ($post['result'] as $key => $value) {
					$html .= '
		<tr>
			<td>'.esc_html($key).'</td>
			<td>'.esc_html($value).'</td>
		</tr>';
				}
				$html .= '
	</table>';
			} else {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('No data found.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}
			
			$return_data = array(
				'status' => 'OK',
				'html' => $html
			);
			if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
			else echo json_encode($return_data);
		}
		exit;
	}

	function admin_icontact_lists() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			$callback = '';
			$html = '';
			if (isset($_REQUEST['callback'])) {
				header("Content-type: text/javascript");
				$callback = preg_replace('/[^a-zA-Z0-9_]/', '', $_REQUEST['callback']);
			}
			$id = null;
			if (!array_key_exists('param1', $_REQUEST) || empty($_REQUEST['param1']) || !array_key_exists('param2', $_REQUEST) || empty($_REQUEST['param2']) || !array_key_exists('param3', $_REQUEST) || empty($_REQUEST['param3'])) {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('Invalid API credentials.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}
			$this->options['icontact_appid'] = $_REQUEST['param1'];
			$this->options['icontact_apiusername'] = $_REQUEST['param2'];
			$this->options['icontact_apipassword'] = $_REQUEST['param3'];
			$lists = $this->icontact_getlists();
			if (!empty($lists)) {
				$html .= '
	<table class="opd-admin-popup-table">
		<tr>
			<th>'.__('List ID', 'opd').'</th>
			<th>'.__('List Name', 'opd').'</th>
		</tr>';
				foreach ($lists as $key => $value) {
					$html .= '
		<tr>
			<td>'.esc_html($key).'</td>
			<td>'.esc_html($value).'</td>
		</tr>';
				}
				$html .= '
	</table>';
			} else {
				$return_data = array(
					'status' => 'ERROR',
					'message' => esc_html__('No data found.', 'opd')
				);
				if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
				else echo json_encode($return_data);
				exit;
			}
			
			$return_data = array(
				'status' => 'OK',
				'html' => $html
			);
			if (!empty($callback)) echo $callback.'('.json_encode($return_data).')';
			else echo json_encode($return_data);
		}
		exit;
	}

	function aweber_connect() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			if (!isset($_POST['opd_aweber_oauth_id']) || empty($_POST['opd_aweber_oauth_id'])) {
				$return_object = array();
				$return_object['status'] = 'ERROR';
				$return_object['message'] = __('Authorization Code not found.', 'opd');
				echo json_encode($return_object);
				exit;
			}
			$code = trim(stripslashes($_POST['opd_aweber_oauth_id']));
			if (!class_exists('AWeberAPI')) {
				require_once(dirname(__FILE__).'/aweber_api/aweber_api.php');
			}
			$account = null;
			try {
				list($consumer_key, $consumer_secret, $access_key, $access_secret) = AWeberAPI::getDataFromAweberID($code);
			} catch (AWeberAPIException $exc) {
				list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
			} catch (AWeberOAuthDataMissing $exc) {
				list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
			} catch (AWeberException $exc) {
				list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
			}
			if (!$access_secret) {
				$return_object = array();
				$return_object['status'] = 'ERROR';
				$return_object['message'] = __('Invalid Authorization Code!', 'opd');
				echo json_encode($return_object);
				exit;
			} else {
				try {
					$aweber = new AWeberAPI($consumer_key, $consumer_secret);
					$account = $aweber->getAccount($access_key, $access_secret);
				} catch (AWeberException $e) {
					$return_object = array();
					$return_object['status'] = 'ERROR';
					$return_object['message'] = __('Can not access AWeber account!', 'opd');
					echo json_encode($return_object);
					exit;
				}
			}
			$this->options['aweber_consumer_key'] = $consumer_key;
			$this->options['aweber_consumer_secret'] = $consumer_secret;
			$this->options['aweber_access_key'] = $access_key;
			$this->options['aweber_access_secret'] = $access_secret;
			$this->update_options();
			$return_object = array();
			$return_object['status'] = 'OK';
			$return_object['html'] = '
										<tr>
											<th>'.__('Connected', 'opd').':</th>
											<td>
												<a class="opd-button opd-button-small" onclick="return opd_aweber_disconnect(this);"><i class="opd-fa opd-fa-ok"></i><label>Disconnect</label></a>
												<br /><em>'.__('Click the button to disconnect.', 'opd').'</em>
											</td>
										</tr>
										<tr>
											<th>'.__('List ID', 'opd').':</th>
											<td>
												<select name="opd_aweber_listid" style="width: 40%;">
													<option value="">'.__('--- Select List ID ---', 'opd').'</option>';
				$lists = $account->lists;
				foreach ($lists as $list) {
					$return_object['html'] .= '
													<option value="'.$list->id.'"'.($list->id == $this->options['aweber_listid'] ? ' selected="selected"' : '').'>'.$list->name.'</option>';
				}
				$return_object['html'] .= '
												</select>
												<br /><em>'.__('Select your List ID.', 'opd').'</em>
											</td>
										</tr>';
			echo json_encode($return_object);
			exit;
		}
		exit;
	}
	
	function aweber_disconnect() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			$this->options['aweber_consumer_key'] = '';
			$this->options['aweber_consumer_secret'] = '';
			$this->options['aweber_access_key'] = '';
			$this->options['aweber_access_secret'] = '';
			$this->update_options();
			$return_object = array();
			$return_object['status'] = 'OK';
			$return_object['html'] = '
					<tr>
						<th>'.__('Authorization code', 'opd').':</th>
						<td>
							<input type="text" id="opd_aweber_oauth_id" value="" class="widefat opd-input" placeholder="AWeber authorization code">
							<br /><em>Get your authorization code <a target="_blank" href="https://auth.aweber.com/1.0/oauth/authorize_app/'.OPD_AWEBER_APPID.'">'.__('here', 'opd').'</a></em>.
						</td>
					</tr>
					<tr>
						<th></th>
						<td style="vertical-align: middle;">
							<a class="opd-button opd-button-small" onclick="return opd_aweber_connect(this);"><i class="opd-fa opd-fa-ok"></i><label>Connect</label></a>
						</td>
					</tr>';
			echo json_encode($return_object);
			exit;
		}
		exit;
	}
	function admin_save_settings() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			foreach ($this->options as $key => $value) {
				if (isset($_POST['opd_'.$key])) {
					$this->options[$key] = stripslashes($_POST['opd_'.$key]);
				}
			}
			if (isset($_POST["opd_thanksgiving_enable"])) $this->options['thanksgiving_enable'] = "on";
			else $this->options['thanksgiving_enable'] = "off";
			if (isset($_POST["opd_mail_enable"])) $this->options['mail_enable'] = "on";
			else $this->options['mail_enable'] = "off";
			if (isset($_POST["opd_mail_from"])) $this->options['mail_from'] = "on";
			else $this->options['mail_from'] = "off";
			if (isset($_POST["opd_mailchimp_double"])) $this->options['mailchimp_double'] = "on";
			else $this->options['mailchimp_double'] = "off";
			if (isset($_POST["opd_mailchimp_enable"])) $this->options['mailchimp_enable'] = "on";
			else $this->options['mailchimp_enable'] = "off";
			if (isset($_POST["opd_icontact_enable"])) $this->options['icontact_enable'] = "on";
			else $this->options['icontact_enable'] = "off";
			if (isset($_POST["opd_campaignmonitor_enable"])) $this->options['campaignmonitor_enable'] = "on";
			else $this->options['campaignmonitor_enable'] = "off";
			if (isset($_POST["opd_getresponse_enable"])) $this->options['getresponse_enable'] = "on";
			else $this->options['getresponse_enable'] = "off";
			if (isset($_POST["opd_madmimi_enable"])) $this->options['madmimi_enable'] = "on";
			else $this->options['madmimi_enable'] = "off";
			if (isset($_POST["opd_disable_name"])) $this->options['disable_name'] = "on";
			else $this->options['disable_name'] = "off";
			if (isset($_POST["opd_gdpr_enable"])) $this->options['gdpr_enable'] = "on";
			else $this->options['gdpr_enable'] = "off";
			if (isset($_POST["opd_aweber_enable"])) $this->options['aweber_enable'] = "on";
			else $this->options['aweber_enable'] = "off";
			if (isset($_POST["opd_mymail_enable"])) $this->options['mymail_enable'] = "on";
			else $this->options['mymail_enable'] = "off";
			if (isset($_POST["opd_mymail_double"])) $this->options['mymail_double'] = "on";
			else $this->options['mymail_double'] = "off";
			if (isset($_POST['opd_email_validation'])) $this->options['email_validation'] = 'on';
			else $this->options['email_validation'] = 'off';
			if (isset($_POST["opd_sendy_enable"])) $this->options['sendy_enable'] = "on";
			else $this->options['sendy_enable'] = "off";
			if (isset($_POST["opd_benchmark_enable"])) $this->options['benchmark_enable'] = "on";
			else $this->options['benchmark_enable'] = "off";
			if (isset($_POST["opd_benchmark_double"])) $this->options['benchmark_double'] = "on";
			else $this->options['benchmark_double'] = "off";
			if (isset($_POST['opd_ga_tracking'])) $this->options['ga_tracking'] = 'on';
			else $this->options['ga_tracking'] = 'off';
			if (isset($_POST['opd_media_secure'])) $this->options['media_secure'] = 'on';
			else $this->options['media_secure'] = 'off';
			if (isset($_POST['opd_xsendfile'])) $this->options['xsendfile'] = 'on';
			else $this->options['xsendfile'] = 'off';

			$emails = array();
			$raw_emails = explode(',', $this->options['mail_email']);
			foreach ($raw_emails as $email) {
				$email = trim($email);
				if (!empty($email)) {
					if (preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,19})$/i", $email)) $emails[] = $email;
				}
			}
			$this->options['mail_email'] = implode(', ', $emails);

			$errors = array();
			if ($this->options['thanksgiving_enable'] == 'on') {
				if (!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,19})$/i", $this->options['from_email']) || strlen($this->options['from_email']) == 0) $errors[] = __('Sender e-mail must be valid e-mail address.', 'opd');
				if (strlen($this->options['from_name']) < 3) $errors[] = __('Sender name is too short.', 'opd');
				if (strlen($this->options['thanksgiving_email_subject']) < 3) $errors[] = __('Thanksgiving e-mail subject must contain at least 3 characters.', 'opd');
				else if (strlen($this->options['thanksgiving_email_subject']) > 64) $errors[] = __('Thanksgiving e-mail subject must contain maximum 64 characters.', 'opd');
				if (strlen($this->options['thanksgiving_email_body']) < 3) $errors[] = __('Thanksgiving e-mail body must contain at least 3 characters.', 'opd');
			}
			if (strlen($this->options['thanks_message']) < 3) $errors[] = __('Redirecting message is too short.', 'opd');
			if (strlen($this->options['placeholder_name']) < 3) $errors[] = __('"Name" field placeholder is too short.', 'opd');
			if (strlen($this->options['placeholder_email']) < 3) $errors[] = __('"E-mail" field placeholder is too short.', 'opd');
			if (strlen($this->options['button_label']) < 2) $errors[] = __('"Subscribe" button label is too short.', 'opd');
			if (strlen($this->options['link_lifetime']) > 0 && $this->options['link_lifetime'] != preg_replace('/[^0-9]/', '', $this->options['link_lifetime'])) $errors[] = __('Link lifetime must be a valid integer value.', 'opd');
			
			if (strlen($this->options['box_color']) > 0 && $this->get_rgb($this->options['box_color']) === false) $errors[] = __('Box background color must be a valid value.', 'opd');
			if (strlen($this->options['box_border_color']) > 0 && $this->get_rgb($this->options['box_border_color']) === false) $errors[] = __('Box border color must be a valid value.', 'opd');
			if (strlen($this->options['box_font_color']) > 0 && $this->get_rgb($this->options['box_font_color']) === false) $errors[] = __('Font color must be a valid value.', 'opd');
			if (strlen($this->options['input_border_color']) > 0 && $this->get_rgb($this->options['input_border_color']) === false) $errors[] = __('Input field border color must be a valid value.', 'opd');
			if (strlen($this->options['input_background_color']) > 0 && $this->get_rgb($this->options['input_background_color']) === false) $errors[] = __('Input field background color must be a valid value.', 'opd');
			if (floatval($this->options['input_background_opacity']) < 0 || floatval($this->options['input_background_opacity']) > 1) $errors[] = __('Input field background opacity must be in a range [0...1].', 'opd');
			if (strlen($this->options['input_font_color']) == 0 || $this->get_rgb($this->options['input_font_color']) === false) $errors[] = __('I font color must be a valid value.', 'opd');
			if (strlen($this->options['button_color']) == 0 || $this->get_rgb($this->options['button_color']) === false) $errors[] = __('Button color must be a valid value.', 'opd');
			if (strlen($this->options['button_font_color']) == 0 || $this->get_rgb($this->options['button_font_color']) === false) $errors[] = __('Button font color must be a valid value.', 'opd');
			if (strlen($this->options['box_font_size']) > 0 && $this->options['box_font_size'] != preg_replace('/[^0-9]/', '', $this->options['box_font_size']) && ($this->options['box_font_size'] > 72 || $this->options['box_font_size'] < 10)) $errors[] = __('Font size must be in a range [10...72].', 'opd');
			if (strlen($this->options['input_font_size']) > 0 && $this->options['input_font_size'] != preg_replace('/[^0-9]/', '', $this->options['input_font_size']) && ($this->options['input_font_size'] > 72 || $this->options['input_font_size'] < 10)) $errors[] = __('Input field font size must be in a range [10...72].', 'opd');
			if (strlen($this->options['button_font_size']) > 0 && $this->options['button_font_size'] != preg_replace('/[^0-9]/', '', $this->options['button_font_size']) && ($this->options['button_font_size'] > 72 || $this->options['button_font_size'] < 10)) $errors[] = __('Button font size must be in a range [10...72].', 'opd');

			if (strlen($this->options['expired_url']) == 0 || !preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $this->options['expired_url'])) $errors[] = __('Invalid expired link redirection URL.', 'opd');
			if (strlen($this->options['amazon_access_key']) != 0 || strlen($this->options['amazon_secret_key']) != 0 || strlen($this->options['amazon_bucket']) != 0) {
				if (strlen($this->options['amazon_access_key']) == 0) $errors[] = __('Amazon Access Key can not be empty.', 'opd');
				if (strlen($this->options['amazon_secret_key']) == 0) $errors[] = __('Amazon Secret Key can not be empty.', 'opd');
				if (strlen($this->options['amazon_bucket']) == 0) $errors[] = __('Amazon S3 Bucket can not be empty.', 'opd');
			}
			
			if ($this->options['mail_enable'] == 'on') {
				$emails = explode(',', $this->options['mail_email']);
				$emails_found = false;
				$emails_invalid = false;
				foreach ($emails as $email) {
					$email = trim($email);
					if (!empty($email)) {
						if (!preg_match("/^[_a-z0-9-+]+(\.[_a-z0-9-+]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,19})$/i", $email)) $emails_invalid = true;
						else $emails_found = true;
					}
				}
				if (!$emails_found) $errors[] = __('Admin e-mail must be valid e-mail address.', 'opd');
				else if ($emails_invalid) $errors[] = __('Admin e-mail must be valid e-mail address.', 'opd');
				if (strlen($this->options['mail_subject']) < 3) $errors[] = __('Notification subject must contain at least 3 characters.', 'opd');
				else if (strlen($this->options['mail_subject']) > 64) $errors[] = __('Notification subject must contain maximum 64 characters.', 'opd');
				if (strlen($this->options['mail_message']) < 3) $errors[] = __('Notification body must contain at least 3 characters.', 'opd');
			}
			
			if ($this->options['mailchimp_enable'] == 'on') {
				if (empty($this->options['mailchimp_api_key']) || strpos($this->options['mailchimp_api_key'], '-') === false) $errors[] = __('Invalid MailChimp API Key.', 'opd');
				if (empty($this->options['mailchimp_list_id'])) $errors[] = __('Invalid MailChimp List ID.', 'opd');
			}
			if ($this->options['icontact_enable'] == 'on') {
				if (empty($this->options['icontact_appid'])) $errors[] = __('Invalid iContact AppID.', 'opd');
				if (empty($this->options['icontact_apiusername'])) $errors[] = __('Invalid iContact API Username.', 'opd');
				if (empty($this->options['icontact_apipassword'])) $errors[] = __('Invalid iContact API Password.', 'opd');
				if (empty($this->options['icontact_listid'])) $errors[] = __('Invalid iContact List ID.', 'opd');
			}
			if ($this->options['campaignmonitor_enable'] == 'on') {
				if (empty($this->options['campaignmonitor_api_key'])) $errors[] = __('Invalid Campaign Monitor API Key.', 'opd');
				if (empty($this->options['campaignmonitor_list_id'])) $errors[] = __('Invalid Campaign Monitor List ID.', 'opd');
			}
			if ($this->options['getresponse_enable'] == 'on') {
				if (empty($this->options['getresponse_api_key'])) $errors[] = __('Invalid GetResponse API Key.', 'opd');
				if (empty($this->options['getresponse_list_id'])) $errors[] = __('Invalid GetResponse Campaign ID.', 'opd');
			}
			if ($this->options['aweber_enable'] == 'on') {
				if (empty($this->options['aweber_access_secret'])) $errors[] = __('Invalid AWeber Connection.', 'opd');
				else if (empty($this->options['aweber_listid'])) $errors[] = __('Invalid AWeber List ID.', 'opd');
			}
			if ($this->options['mymail_enable'] == 'on') {
				if (empty($this->options['mymail_listid'])) $errors[] = __('Invalid MyMail List ID.', 'opd');
			}
			if ($this->options['madmimi_enable'] == 'on') {
				if (empty($this->options['madmimi_login'])) $errors[] = __('Invalid Mad Mimi login.', 'opd');
				if (empty($this->options['madmimi_api_key'])) $errors[] = __('Invalid Mad Mimi API key.', 'opd');
				if (empty($this->options['madmimi_list_id'])) $errors[] = __('Invalid Mad Mimi list ID.', 'opd');
			}
			if ($this->options['sendy_enable'] == 'on') {
				if (strlen($this->options['sendy_url']) == 0 || !preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $this->options['sendy_url'])) $errors[] = __('Sendy installation URL must be a valid URL.', 'opd');
				if (empty($this->options['sendy_listid'])) $errors[] = __('Invalid Sendy list ID.', 'opd');
			}
			if ($this->options['benchmark_enable'] == 'on') {
				if (empty($this->options['benchmark_api_key'])) $errors[] = __('Invalid Benchmark Email API key.', 'opd');
				if (empty($this->options['benchmark_list_id'])) $errors[] = __('Invalid Benchmark Email list ID.', 'opd');
			}
			if (!empty($errors)) {
				$return_object = array();
				$return_object['status'] = 'ERROR';
				$return_object['message'] = __('Attention! Please correct errors and try again.', 'opd').'<ul><li>'.implode('</li><li>', $errors).'</li></ul>';
				echo json_encode($return_object);
				exit;
			}
			$this->update_options();
			$return_object = array();
			$return_object['status'] = 'OK';
			$return_object['message'] = __('Settings successfully <strong>saved</strong>.', 'opd');
			echo json_encode($return_object);
			exit;
		}
	}
	
	function admin_files() {
		global $wpdb;

		if (isset($_GET["s"])) $search_query = trim(stripslashes($_GET["s"]));
		else $search_query = "";
		
		$tmp = $wpdb->get_row("SELECT COUNT(*) AS total FROM ".$wpdb->prefix."sad_files WHERE deleted = '0'".((strlen($search_query) > 0) ? "AND (filename_original LIKE '%".addslashes($search_query)."%' OR title LIKE '%".addslashes($search_query)."%')" : ""), ARRAY_A);
		$total = $tmp["total"];
		$totalpages = ceil($total/OPD_RECORDS_PER_PAGE);
		if ($totalpages == 0) $totalpages = 1;
		if (isset($_GET["p"])) $page = intval($_GET["p"]);
		else $page = 1;
		if ($page < 1 || $page > $totalpages) $page = 1;
		$switcher = $this->page_switcher(admin_url('admin.php').'?page=opd'.((strlen($search_query) > 0) ? "&s=".rawurlencode($search_query) : ""), $page, $totalpages);

		$sql = "SELECT * FROM ".$wpdb->prefix."sad_files WHERE deleted = '0'".((strlen($search_query) > 0) ? " AND (filename_string LIKE '%".addslashes($search_query)."%' OR title LIKE '%".addslashes($search_query)."%')" : "")." ORDER BY registered DESC LIMIT ".(($page-1)*OPD_RECORDS_PER_PAGE).", ".OPD_RECORDS_PER_PAGE;
		$rows = $wpdb->get_results($sql, ARRAY_A);
		if (!empty($this->error)) $message = "<div class='error'><p>".$this->error."</p></div>";
		else if (!empty($this->info)) $message = "<div class='updated'><p>".$this->info."</p></div>";
		else $message = '';

		echo '
			<div class="wrap admin_opd_wrap">
				<h2>'.__('Opt-In Downloads - Files', 'opd').'</h2>
				'.$message.'
				<form action="'.admin_url('admin.php').'" method="get" class="uap-filter-form opd-filter-form">
				<input type="hidden" name="page" value="opd" />
				<label>'.__('Search:', 'opd').'</label>
				<input type="text" name="s" value="'.esc_html($search_query).'" style="width: 200px;" class="form-control">
				<input type="submit" class="button-secondary action" value="'.__('Search', 'opd').'" />
				'.((strlen($search_query) > 0) ? '<input type="button" class="button-secondary action" value="'.__('Reset search results', 'opd').'" onclick="window.location.href=\''.admin_url('admin.php').'?page=opd\';" />' : '').'
				</form>
				<div class="opd_buttons"><a class="opd-button opd-button-small" href="'.admin_url('admin.php').'?page=opd-add"><i class="opd-fa opd-fa-plus"></i><label>'.__('Create New File', 'opd').'</label></a></div>
				<div class="opd_pageswitcher">'.$switcher.'</div>
				<table class="opd-records">
				<tr>
					<th>'.__('File', 'opd').'</th>
					<th style="width: 240px;">'.__('Shortcode', 'opd').'</th>
					<th style="width: 70px;">'.__('Links', 'opd').'</th>
					<th style="width: 130px;"></th>
				</tr>';
		if (sizeof($rows) > 0) {
			foreach ($rows as $row) {
				$title = trim($row['title']);
				if (empty($title)) $title = $row['filename_string'];
				$source_string = '';
				switch ($row['source']) {
					case 'file':
						$source_string = __('File', 'opd').': ';
						break;
					case 'url':
						$source_string = __('URL', 'opd').': ';
						break;
					case 'media-library':
						$source_string = __('Media Library', 'opd').': ';
						break;
					case 'amazon-s3':
						$source_string = __('Amazon S3', 'opd').': ';
						break;
					default:
						break;
				}
				$sql = "SELECT COUNT(id) AS total FROM ".$wpdb->prefix."sad_users WHERE file_id = '".$row["id"]."' AND deleted = '0'";
				$links = $wpdb->get_row($sql, ARRAY_A);
				echo '
				<tr>
					<td><strong>'.esc_html($title).'</strong><br /><em>'.esc_html($source_string.$row['filename_string']).'</em></td>
					<td><input type="text" class="widefat" onclick="this.focus();this.select();" readonly="readonly" value="'.(defined('UAP_CORE') ? esc_html('<div class="opd" data-id="'.$row['id'].'"></div>') : esc_html('[opd id="'.$row['id'].'"]')).'"></td>
					<td style="text-align: right;">'.intval($links["total"]).'</td>
					<td class="opd-item-actions">
						<a href="'.admin_url('admin.php').'?page=opd-add&id='.$row['id'].'" title="'.__('Edit file details', 'opd').'"><i class="opd-fa opd-fa-pencil"></i></a>
						<a href="'.admin_url('admin.php').'?action=opd-add-link&id='.$row['id'].'" title="'.__('Generate download link', 'opd').'" onclick="return opd_confirm_redirect(this, \'continue\');"><i class="opd-fa opd-fa-link"></i></a>
						<a href="'.admin_url('admin.php').'?page=opd-users&id='.$row['id'].'" title="'.__('Download links', 'opd').'"><i class="opd-fa opd-fa-list-alt"></i></a>
						<a href="'.admin_url('admin.php').'?action=opd-download&id='.$row['id'].'" title="'.__('Download file', 'opd').'"><i class="opd-fa opd-fa-download"></i></a>
						<a href="'.admin_url('admin.php').'?action=opd-delete&id='.$row['id'].'" title="'.__('Delete file', 'opd').'" onclick="return opd_confirm_redirect(this, \'delete\');"><i class="opd-fa opd-fa-trash"></i></a>
					</td>
				</tr>';
			}
		} else {
			echo '
				<tr><td colspan="5" style="padding: 20px; text-align: center;">'.((strlen($search_query) > 0) ? __('No results found for', 'opd').' "<strong>'.esc_html($search_query).'</strong>"' : __('List is empty.', 'opd')).'</td></tr>';
		}
		echo '
				</table>
				<div class="opd_buttons"><a class="opd-button opd-button-small" href="'.admin_url('admin.php').'?page=opd-add"><i class="opd-fa opd-fa-plus"></i><label>'.__('Create New File', 'opd').'</label></a></div>
				<div class="opd_pageswitcher">'.$switcher.'</div>
			</div>';
		echo $this->admin_modal_html();
	}

	function admin_add_file() {
		global $wpdb;

		$file_details = null;
		if (isset($_GET["id"]) && !empty($_GET["id"])) {
			$file_details = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."sad_files WHERE id = '".intval($_GET["id"])."' AND deleted = '0'", ARRAY_A);
		}
		if (!empty($file_details) && is_array($file_details) && array_key_exists('options', $file_details)) {
			$file_options = json_decode($file_details['options'], true);
			if (empty($file_options)) $file_options = $this->default_file_options;
		} else $file_options = $this->default_file_options;

		$files = array();
		$upload_dir = wp_upload_dir();
		if (file_exists($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR) && is_dir($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR)) {
			$dircontent = scandir($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR);
			for ($i=0; $i<sizeof($dircontent); $i++) {
				if ($dircontent[$i] != "." && $dircontent[$i] != ".." && $dircontent[$i] != "index.html" && $dircontent[$i] != ".htaccess") {
					if (is_file($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.$dircontent[$i])) {
						$files[] = $dircontent[$i];
					}
				}
			}
		}
		
		echo '
		<div class="wrap opd">
			<h2>'.(!empty($file_details) ? __('Opt-In Downloads - Edit File', 'opd') : __('Opt-In Downloads - Add File', 'opd')).'</h2>
			<form class="opd-form" enctype="multipart/form-data" method="post" style="margin: 0px" action="'.admin_url('admin.php').'">
			<div class="postbox-container" style="width: 100%;">
				<div class="metabox-holder">
					<div class="meta-box-sortables ui-sortable">
						<div class="postbox opd_postbox">
							<!--<div class="handlediv" title="Click to toggle"><br></div>-->
							<h3 class="hndle" style="cursor: default;"><span>'.(!empty($file_details) ? __('Edit file', 'opd') : __('Add file', 'opd')).'</span></h3>
							<div class="inside">
								<table class="opd_useroptions">
									<tr>
										<th>'.__('Title', 'opd').':</th>
										<td>
											<input type="text" name="title" value="'.(!empty($file_details) ? esc_html($file_details['title']) : '').'" class="widefat">
											<br /><em>'.__('Enter the title of file. If you leave this field blank, then original file name will be the title.', 'opd').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Intro', 'opd').':</th>
										<td>
											<textarea class="widefat" name="intro" style="height: 120px;">'.(!empty($file_details) ? esc_html($file_details['intro']) : '').'</textarea>
											<br /><em>'.__('Enter the content of opt-in box. HTML allowed. Opt-in form is inserted below this content. Leave this field empty to use Intro from Settings page.', 'opd').'</em>
										</td>
									</tr> 
									<tr>
										<th>'.__('Source', 'opd').':</th>
										<td>
											<input class="opd-tile" type="radio" name="source" id="opd-source-file" value="file"'.((!empty($file_details) && $file_details['source'] == 'file') || empty($file_details) ? ' checked="checked"' : '').' onchange="opd_change_source();" /><label for="opd-source-file">'.__('File', 'opd').'</label>';
		if (!defined('UAP_CORE')) {
			echo '
											<input class="opd-tile" type="radio" name="source" id="opd-source-media-library" value="media-library"'.(!empty($file_details) && $file_details['source'] == 'media-library' ? ' checked="checked"' : '').' onchange="opd_change_source();" /><label for="opd-source-media-library">'.__('Media Library', 'opd').'</label>';
		}
		echo '
											<input class="opd-tile" type="radio" name="source" id="opd-source-url" value="url"'.(!empty($file_details) && $file_details['source'] == 'url' ? ' checked="checked"' : '').' onchange="opd_change_source();" /><label for="opd-source-url">'.__('URL', 'opd').'</label>
											<input class="opd-tile" type="radio" name="source" id="opd-source-amazon-s3" value="amazon-s3"'.(!empty($file_details) && $file_details['source'] == 'amazon-s3' ? ' checked="checked"' : '').' onchange="opd_change_source();" /><label for="opd-source-amazon-s3">'.__('Amazon S3', 'opd').'</label>
											<br /><em>'.__('Select the source of the file.', 'opd').'</em>
										</td>
									</tr>
									<tr class="opd-source-data opd-source-file"'.((!empty($file_details) && $file_details['source'] == 'file') || empty($file_details) ? ' style="display: table-row;"' : '').'>
										<th>'.__('File', 'opd').':</th>
										<td>
											<select name="source-file" id="opd-fileselector">
												<option value="">-- '.__('Select available file', 'opd').' --</option>';
		for ($i=0; $i<sizeof($files); $i++) {
			echo '
												<option value="'.esc_html($files[$i]).'"'.(!empty($file_details) && $file_details['source'] == 'file' && $files[$i] == $file_details['filename'] ? ' selected="selected"' : '').'>'.esc_html($files[$i]).'</option>';
		}
		echo '
											</select><br /><em>'.sprintf(__('Select any available file from folder <strong>%s</strong> or upload new file below.', 'opd'), $upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR).'</em><br />
											<a class="opd-button" id="opd-source-file-upload-button" data-select="opd-fileselector" data-label="'.__('Upload File', 'opd').'" data-loading="'.__('Uploading...', 'opd').'" onclick="jQuery(\'.opd-form-upload input[type=file]\').click(); return false;"><i class="opd-fa opd-fa-upload"></i><label>'.__('Upload File', 'opd').'<label></a>
											<br /><em>'.__('Choose file to upload.', 'opd').'</em>
										</td>
									</tr>
									<tr class="opd-source-data opd-source-url"'.(!empty($file_details) && $file_details['source'] == 'url' ? ' style="display: table-row;"' : '').'>
										<th>'.__('URL', 'opd').':</th>
										<td>
											<input type="text" name="source-url" value="'.(!empty($file_details) && $file_details['source'] == 'url' ? esc_html($file_details['filename']) : '').'" class="widefat" />
											<br /><em>'.__('Enter the URL of the file that you want to share with subscribers. This URL will be replaced by temporary encrypted URL automatically.', 'opd').'</em>
										</td>
									</tr>
									<tr class="opd-source-data opd-source-amazon-s3"'.(!empty($file_details) && $file_details['source'] == 'amazon-s3' ? ' style="display: table-row;"' : '').'>
										<th>'.__('File', 'opd').':</th>
										<td>
											<input type="text" name="source-amazon-s3" value="'.(!empty($file_details) && $file_details['source'] == 'amazon-s3' ? esc_html($file_details['filename']) : '').'" class="widefat" />
											<br /><em>'.__('Enter the name of the file, located in certain bucket on Amazon S3 servers. Do not forget to set Amazon S3 parameters on Settings page.', 'opd').'</em>
										</td>
									</tr>';
		if (!defined('UAP_CORE')) {
			echo '
									<tr class="opd-source-data opd-source-media-library"'.(!empty($file_details) && $file_details['source'] == 'media-library' ? ' style="display: table-row;"' : '').'>
										<th>'.__('File', 'opd').':</th>
										<td>
											<input type="text" name="source-media-library-name" value="'.(!empty($file_details) && $file_details['source'] == 'media-library' ? esc_html($file_details['filename_string']) : '').'" class="widefat" readonly="readonly" onclick="opd_set_media(this);" />
											<input type="hidden" name="source-media-library" value="'.(!empty($file_details) && $file_details['source'] == 'media-library' ? esc_html($file_details['filename']) : '').'" />
											<br /><em>'.__('Select the file from Media Library.', 'opd').'</em>
										</td>
									</tr>';
		}
		echo '
									<tr>
										<th>'.__('Custom Welcome Message', 'opd').':</th>
										<td>
											<input type="checkbox" id="opd-welcome-email-custom" name="opd-options-welcome-email-custom" '.($file_options['welcome-email-custom'] == "on" ? 'checked="checked"' : '').'" onclick="opd_switch_welcome_email_custom();"> '.__('Send custom welcome message', 'opd').'
											<br /><em>'.__('Please tick checkbox if you want to send custom welcome message to subscriber. If disabled, default welcome message will be sent.', 'opd').'</em>
										</td>
									</tr>
									<tr class="opd-welcome-email-custom"'.($file_options['welcome-email-custom'] != "on" ? ' style="display:none;"' : '').'>
										<th>'.__('Subject', 'opd').':</th>
										<td>
											<input type="text" id="opd-welcome-email-subject" name="opd-options-welcome-email-subject" value="'.esc_html($file_options['welcome-email-subject']).'" class="widefat">
											<br /><em>'.__('In case of successful subscription, your visitors receive e-mail message which contains download link. This is the subject field of the message.', 'opd').'</em>
										</td>
									</tr>
									<tr class="opd-welcome-email-custom"'.($file_options['welcome-email-custom'] != "on" ? ' style="display:none;"' : '').'>
										<th>'.__('Message', 'opd').':</th>
										<td>
											<textarea id="opd-welcome-email-body" name="opd-options-welcome-email-body" class="widefat" style="height: 120px;">'.esc_html($file_options['welcome-email-body']).'</textarea>
											<br /><em>'.__('This e-mail message is sent to your visitor in case of successful subscription. You can use the following keywords: {download_link}, {name}, {e-mail}.', 'opd').'</em>
										</td>
									</tr>
								</table>
							</div>
						</div>
					</div>
				</div>
				<hr>
				<div class="opd-button-container">
					<input type="hidden" name="action" value="opd-save-file" />
					'.(!empty($file_details) ? '<input type="hidden" name="opd-id" value="'.$file_details['id'].'" />' : '').'
					<a class="opd-button" onclick="return opd_save_file(this);"><i class="opd-fa opd-fa-ok"></i><label>'.__('Submit Details', 'opd').'</label></a>
				</div>
			</div>
			</form>
			<form class="opd-form-upload" action="'.admin_url('admin-ajax.php').'" method="POST" enctype="multipart/form-data" target="opd-iframe-upload" data-button="opd-source-file-upload-button" onsubmit="return opd_uploader_start(this);" style="display: none !important; width: 0 !important; height: 0 !important;">
				<input type="hidden" name="action" value="opd-file-upload" />
				<input type="file" name="file" onchange="jQuery(this).parent().submit();" style="display: none !important; width: 0 !important; height: 0 !important;" />
				<input type="submit" value="Upload" style="display: none !important; width: 0 !important; height: 0 !important;" />
			</form>											
			<iframe data-loading="false" data-button="opd-source-file-upload-button" id="opd-iframe-upload" name="opd-iframe-upload" src="about:blank" onload="opd_uploader_finish(this);" style="display: none !important; width: 0 !important; height: 0 !important;"></iframe>
			<script>
			function opd_switch_welcome_email_custom() {
				if (jQuery("#opd-welcome-email-custom").is(":checked")) jQuery(".opd-welcome-email-custom").fadeIn(300);
				else jQuery(".opd-welcome-email-custom").fadeOut(300);
				return false;
			}
			</script>
		</div>
		<div id="opd-global-message"></div>';
	}
	
	function admin_upload() {
		header('Content-Type: application/json');
		if (is_uploaded_file($_FILES["file"]["tmp_name"])) {
			$upload_dir = wp_upload_dir();
			$filename = $this->get_filename($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR, $_FILES["file"]["name"]);
			if (!move_uploaded_file($_FILES["file"]["tmp_name"], $upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.$filename)) {
				$return_object = array();
				$return_object['status'] = 'ERROR';
				$return_object['message'] = __('Unable to save uploaded file on server.', 'opd');
				echo json_encode($return_object);
				exit;
			}
			$files = array();
			if (file_exists($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR) && is_dir($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR)) {
				$dircontent = scandir($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR);
				for ($i=0; $i<sizeof($dircontent); $i++) {
					if ($dircontent[$i] != "." && $dircontent[$i] != ".." && $dircontent[$i] != "index.html" && $dircontent[$i] != ".htaccess") {
						if (is_file($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.$dircontent[$i])) {
							$files[] = $dircontent[$i];
						}
					}
				}
			}
			if (empty($files)) {
				$return_object = array();
				$return_object['status'] = 'ERROR';
				$return_object['message'] = __('Unable to save uploaded file on server.', 'opd');
				echo json_encode($return_object);
				exit;
			}
			$html = '<option value="">-- '.__('Select available file', 'opd').' --</option>';
			foreach ($files as $file) {
				$html .= '<option value="'.esc_html($file).'"'.($file == $filename ? ' selected="selected"' : '').'>'.esc_html($file).'</option>';
			}
			$return_object = array();
			$return_object['status'] = 'OK';
			$return_object['html'] = $html;
			$return_object['message'] = __('File successfully uploaded.', 'opd');
			echo json_encode($return_object);
			exit;
		}
		$return_object = array();
		$return_object['status'] = 'ERROR';
		$return_object['message'] = __('File was not uploaded properly.', 'opd');
		echo json_encode($return_object);
		exit;
	}

	function admin_save_file() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			$id = '';
			if (array_key_exists('opd-id', $_REQUEST)) $id = stripslashes(trim($_REQUEST['opd-id']));
			$title = '';
			if (array_key_exists('title', $_REQUEST)) $title = stripslashes(trim($_REQUEST['title']));
			$intro = '';
			if (array_key_exists('intro', $_REQUEST)) $intro = stripslashes(trim($_REQUEST['intro']));
			$source = 'file';
			if (array_key_exists('source', $_REQUEST)) $source = stripslashes(trim($_REQUEST['source']));

			$error = '';
			$filename = '';
			$filename_string = '';

			$file_options = array();
			foreach ($this->default_file_options as $key => $value) {
				if (array_key_exists('opd-options-'.$key, $_REQUEST)) $file_options[$key] = stripslashes(trim($_REQUEST['opd-options-'.$key]));
				else $file_options[$key] = $value;
			}
			if (array_key_exists('opd-options-welcome-email-custom', $_REQUEST)) $file_options['welcome-email-custom'] = 'on';
			else $file_options['welcome-email-custom'] = 'off';
			if ($file_options['welcome-email-custom'] == 'on') {
				if (empty($file_options['welcome-email-subject'])) $error = __('Welcome Email Subject can not be empty.', 'opd');
				else if (empty($file_options['welcome-email-body'])) $error = __('Welcome Email Message can not be empty.', 'opd');
			}
			
			switch ($source) {
				case 'url':
					if (array_key_exists('source-url', $_REQUEST)) $filename = stripslashes(trim($_REQUEST['source-url']));
					if (empty($filename) || !preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $filename)) $error = __('Invalid URL.', 'opd');
					else $filename_string = $filename;
					break;
				case 'amazon-s3':
					if (array_key_exists('source-amazon-s3', $_REQUEST)) $filename = stripslashes(trim($_REQUEST['source-amazon-s3']));
					if (empty($filename)) $error = __('Invalid Amazon S3 file.', 'opd');
					else $filename_string = $filename;
					break;
				case 'media-library':
					if (array_key_exists('source-media-library', $_REQUEST)) $filename = stripslashes(trim($_REQUEST['source-media-library']));
					if (empty($filename)) $error = __('Invalid Media Library file.', 'opd');
					else {
						$attachment_id = intval($filename);
						$attachment = get_post($attachment_id, ARRAY_A);
						if (is_array($attachment) && array_key_exists('post_type', $attachment) && $attachment['post_type'] == 'attachment') {
							$file = get_attached_file($attachment_id);							
							$filename_string = basename($file);
						} else $error = __('Media Library file not found.', 'opd');
					}
					break;
				case 'file':
					if (array_key_exists('source-file', $_REQUEST)) $filename = stripslashes(trim($_REQUEST['source-file']));
					if (empty($filename)) $error = __('Invalid Amazon S3 file.', 'opd');
					else {
						$upload_dir = wp_upload_dir();
						if (file_exists($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.$filename) && is_file($upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.$filename)) {
							$filename_string = $filename;
						} else $error = __('File not found.', 'opd');
					}
					break;
				default:
					$error = __('Invalid source.', 'opd');
					break;
			}
			
			if (!empty($error)) {
				$return_object = array();
				$return_object['status'] = 'ERROR';
				$return_object['message'] = $error;
				echo json_encode($return_object);
				exit;
			}
			if (!empty($id)) {
				$sql = "UPDATE ".$wpdb->prefix."sad_files SET 
					title = '".esc_sql($title)."', 
					intro = '".esc_sql($intro)."', 
					source = '".esc_sql($source)."', 
					filename = '".esc_sql($filename)."', 
					filename_string = '".esc_sql($filename_string)."',
					options = '".esc_sql(json_encode($file_options))."'
					WHERE id = '".$id."'";
			} else {
				$sql = "INSERT INTO ".$wpdb->prefix."sad_files (
					title, intro, source, filename, filename_string, options, registered, deleted) VALUES (
					'".esc_sql($title)."', '".esc_sql($intro)."', '".esc_sql($source)."', '".esc_sql($filename)."',	'".esc_sql($filename_string)."', '".esc_sql(json_encode($file_options))."', '".time()."', '0')";
			}
			if ($wpdb->query($sql) === false) {
				$return_object = array();
				$return_object['status'] = 'ERROR';
				$return_object['message'] = __('Service is not available', 'opd');
				echo json_encode($return_object);
				exit;
			}
			$return_object = array();
			$return_object['status'] = 'OK';
			$return_object['message'] = __('Record successfully saved.', 'opd');
			$return_object['redirect'] = admin_url('admin.php').'?page=opd';
			echo json_encode($return_object);
			exit;
		}
	}
	
	function admin_users() {
		global $wpdb;

		if (isset($_GET["s"])) $search_query = trim(stripslashes($_GET["s"]));
		else $search_query = "";
		if (isset($_GET["id"])) $file_id = intval(trim(stripslashes($_GET["id"])));
		else $file_id = 0;

		
		$tmp = $wpdb->get_row("SELECT COUNT(*) AS total FROM ".$wpdb->prefix."sad_users WHERE deleted = '0'".($file_id > 0 ? " AND file_id = '".$file_id."'" : "").((strlen($search_query) > 0) ? " AND (name LIKE '%".addslashes($search_query)."%' OR email LIKE '%".addslashes($search_query)."%')" : ""), ARRAY_A);
		$total = $tmp["total"];
		$totalpages = ceil($total/OPD_RECORDS_PER_PAGE);
		if ($totalpages == 0) $totalpages = 1;
		if (isset($_GET["p"])) $page = intval($_GET["p"]);
		else $page = 1;
		if ($page < 1 || $page > $totalpages) $page = 1;
		$switcher = $this->page_switcher(get_bloginfo("wpurl")."/wp-admin/admin.php?page=opd-users".($file_id > 0 ? "&id = '".$file_id."'" : "").((strlen($search_query) > 0) ? "&s=".rawurlencode($search_query) : ""), $page, $totalpages);

		$sql = "SELECT * FROM ".$wpdb->prefix."sad_users WHERE deleted = '0'".($file_id > 0 ? " AND file_id = '".$file_id."'" : "").((strlen($search_query) > 0) ? " AND (name LIKE '%".addslashes($search_query)."%' OR email LIKE '%".addslashes($search_query)."%')" : "")." ORDER BY registered DESC LIMIT ".(($page-1)*OPD_RECORDS_PER_PAGE).", ".OPD_RECORDS_PER_PAGE;
		$rows = $wpdb->get_results($sql, ARRAY_A);
		if (isset($_GET['deleted'])) $message = "<div class='updated'><p>".__('Record(s) successfully deleted!', 'opd')."</p></div>";
		else $message = '';

		echo '
			<div class="wrap admin_opd_wrap">
				<h2>'.__('Opt-In Downloads - Log', 'opd').'</h2>
				'.$message.'
				<form action="'.admin_url('admin.php').'" method="get" class="uap-filter-form opd-filter-form">
				<input type="hidden" name="page" value="opd-users" />
				'.($file_id > 0 ? '<input type="hidden" name="id" value="'.$file_id.'" />' : '').'
				<label>'.__('Search:', 'opd').'</label>
				<input type="text" name="s" value="'.esc_html($search_query).'" style="width: 200px;" class="form-control">
				<input type="submit" class="button-secondary action" value="'.__('Search', 'opd').'" />
				'.((strlen($search_query) > 0) ? '<input type="button" class="button-secondary action" value="'.__('Reset search results', 'opd').'" onclick="window.location.href=\''.admin_url('admin.php').'?page=opd-users'.($file_id > 0 ? '&id='.$file_id : '').'\';" />' : '').'
				</form>
				<div class="opd_buttons"><a class="opd-button opd-button-small" href="'.admin_url('admin.php').'?action=opd-csv"><i class="opd-fa opd-fa-download"></i><label>'.__('CSV Export', 'opd').'</label></a></div>
				<div class="opd_pageswitcher">'.$switcher.'</div>
				<table class="opd-records">
				<tr>
					<th>'.__('Name', 'opd').'</th>
					<th>'.__('E-mail', 'opd').'</th>
					<th>'.__('Download Link', 'opd').'</th>
					<th style="width: 80px;">'.__('Downloads', 'opd').'</th>
					<th style="width: 120px;">'.__('Created', 'opd').'</th>
					<th style="width: 25px;"></th>
				</tr>';
		if (sizeof($rows) > 0) {
			foreach ($rows as $row) {
				switch ($row['source']) {
					case 'media-library':
						$attachment = get_post(intval($row['url']), ARRAY_A);
						if (is_array($attachment) && array_key_exists('post_type', $attachment) && $attachment['post_type'] == 'attachment') {
							$file = 'Media Library: '.$attachment['post_title'];
						} else $file = 'Media Library: not found';
						break;
					case 'amazon-s3':
						$file = 'Amazon S3: '.$row['url'];
						break;
					case 'file':
						$file = 'File: '.$row['url'];
						break;
					default:
						$file = 'URL: '.$row['url'];
						break;
				}
				$temp_url = defined('UAP_CORE') ? admin_url('do.php') : rtrim(get_bloginfo('url'), '/').'/';
				$temp_url .= (strpos($temp_url, '?') == false ? '?' : '&').'opd='.$row['secret_key'];
				echo '
				<tr>
					<td>'.($row['name'] == '' ? '-' : esc_html($row['name'])).'</td>
					<td>'.esc_html($row['email']).'</td>
					<td><input type="text" class="widefat" onclick="this.focus();this.select();" readonly="readonly" value="'.esc_html($temp_url).'" /><em>'.esc_html($file).'</em></td>
					<td style="text-align: right;">'.esc_html($row['downloads']).'</td>
					<td>'.date("Y-m-d H:i", $row['registered']).'</td>
					<td class="opd-item-actions">
						<a href="'.admin_url('admin.php').'?action=opd-delete-record&id='.$row['id'].'" title="'.__('Delete record', 'opd').'" onclick="return opd_confirm_redirect(this, \'delete\');"><i class="opd-fa opd-fa-trash"></i></a>
					</td>
				</tr>';
			}
		} else {
			echo '
				<tr><td colspan="6" style="padding: 20px; text-align: center;">'.((strlen($search_query) > 0) ? __('No results found for', 'opd').' "<strong>'.esc_html($search_query).'</strong>"' : __('List is empty.', 'opd')).'</td></tr>';
		}
		echo '
				</table>
				<div class="opd_buttons">
					<a class="opd-button opd-button-small" href="'.admin_url('admin.php').'?action=opd-deleteall" onclick="return opd_confirm_redirect(this, \'delete-all\');"><i class="opd-fa opd-fa-trash"></i><label>'.__('Delete All', 'opd').'</label></a>
					<a class="opd-button opd-button-small" href="'.admin_url('admin.php').'?action=opd-csv"><i class="opd-fa opd-fa-download"></i><label>'.__('CSV Export', 'opd').'</label></a>
				</div>
				<div class="opd_pageswitcher">'.$switcher.'</div>
			</div>';
		echo $this->admin_modal_html();
	}

	function admin_faq() {
		echo '
			<div class="wrap admin_opd_wrap">
				<h2>'.__('Opt-In Downloads - FAQ', 'opd').'</h2>
				<h3>How does Opt-In Downloads work?</h3>
				<p>Opt-In Downloads uses very simple workflow.
					<ol>
						<li>You insert special shortcode into post/page content. This shortcode generates opt-in form.</li>
						<li>Once users submitted their contact details through that form, they receive Welcome E-mail message with unique encrypted link which is valid several hours.</li>
					</ol>
				</p>
				<hr>
				<h3>You said "Welcome E-mail". What is it?</h3>
				<p>"Welcome E-mail" is an e-mail message which is sent to subscriber\'s e-mail address when he/she submit opt-in form.
				You can configure "Welcome E-mail" on Settings page (Mailing tab).
				</p>
				<hr>
				<h3>OK. What specific shortcode should I insert into post/page content?</h3>
				<p>You can find the shortcode in the appropriate column on <a href="'.admin_url('admin.php').'?page=opd">Files</a> page.
				</p>
				<div class="obsolete-info" style="display: none;">
				<p>It depends on where you host the file. You can host it in <a href="'.admin_url('upload.php').'">Media Library</a> or on 3rd party server.
					<ol>
						<li>If you host the file in <a href="'.admin_url('upload.php').'">Media Library</a>, the shortcode looks like that: <code>[sdfile id="X"]</code>.<br />
						Each file in Media Library has its own shortcode. To find it, just go to Media Library, click desired file and find "Opt-In Downloads" field.</li>
						<li>If you host the file on Amazon S3 servers, the shortcode looks like that: <code>[sdfile s3="file.zip"]</code>.<br />
						Pay attention to <code>s3</code> parameter. This is the file, located in certain bucket on Amazon S3 servers. Do not forget to set Amazon S3 parameters on <a href="'.admin_url('admin.php').'?page=opd-settings#opd-amazon-s3">Settings</a> page.</li>
						<li>If you host the file outside of Media Library, the shortcode looks like that: <code>[sdfile url="http://domain.tld/path/to/file.zip"]</code>.<br />
						Pay attention to <code>url</code> parameter. This is the URL of the file that you want to share with subscribers. This URL will be replaced by temporary encrypted URL automatically.</li>
					</ol>
				</p>
				</div>
				<hr>
				<h3>How long temporary encrypted URL is valid?</h3>
				<p>It completely depends on you. You can configure this paramter on <a href="'.admin_url('admin.php').'?page=opd-settings#opd-downloads">Settings</a> page.</p>
				<hr>
				<h3>What happens if user uses expired link?</h3>
				<p>In this case user is redirected to pre-defined URL. You also can configure it on <a href="'.admin_url('admin.php').'?page=opd-settings#opd-downloads">Settings</a> page.</p>
				<h3>Where can I see the list of temporary encrypted links?</h3>
				<p>Just go to <a href="'.admin_url('admin.php').'?page=opd-users">Log</a> page. There you can see the full list of generated links. Moreover, each link has info about the user who received that link.</p>
				<h3>What happens if I remove temporary encrypted link from Log?</h3>
				<p>In this case the link become invalid and nobody can use it anymore.</p>
			</div>';
	}

	function admin_using() {
		global $wpdb;
		$remote_snippet = '<script id="opd-remote" src="'.plugins_url('/js/opd.js', __FILE__).'?ver='.OPD_VERSION.'" data-handler="'.admin_url('admin-ajax.php').'"></script>';
		echo '
		<div class="wrap opd">
			<h2>'.__('Opt-In Downloads - How To Use', 'opd').'</h2>
			<div class="opd_postbox opd-using-page">
				<h3>Embedding Opt-In Downloads into website</h3>
				<p>To embed Opt-In Downloads into any website you need perform the following steps:</p>
				<ol>
				<li>
					Make sure that website has DOCTYPE. If not, add the following line as a first line of HTML-document:
					<input type="text" readonly="readonly" value="&lt;!DOCTYPE html&gt;" onclick="this.focus();this.select();">
				</li>
				<li>
					Make sure that website loads jQuery version 1.9 or higher. If not, add the following line into head section of HTML-document:
					<input type="text" readonly="readonly" value="&lt;script src=&quot;https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js&quot;&gt;&lt;/script&gt;" onclick="this.focus();this.select();">
				</li>
				<li>
					Copy the following JS-snippet and paste it into your website. You need paste it at the end of <code>&lt;body&gt;</code> section (above closing <code>&lt;/body&gt;</code> tag).
					<input type="text" readonly="readonly" onclick="this.focus();this.select();" value="'.esc_html($remote_snippet).'" />
				</li>
				<li>That\'s it. Integration finished. :-)</li>
				</ol>
				<h3>Using Opt-In Downloads</h3>
				<p>Copy file\'s shortcode and paste it where opt-in form must be. Shortcodes can be found on <a href="'.admin_url('admin.php').'?page=opd">Files</a> page.</p>
			</div>
		</div>';
	}
	
	function add_attachment_fields_to_edit($form_fields, $post) {
		$form_fields["credit"] = array(
			"label" => 'Opt-In Downloads',
			"input" => 'html',
			"html" => '<input type="text" class="text urlfield widefat" onclick="this.focus();this.select();" style="box-sizing: border-box;" readonly="readonly" value="'.esc_html('[sdfile id="'.$post->ID.'"]').'" />',
		);
		return $form_fields;
	}
	
	function admin_request_handler() {
		global $wpdb;
		if (current_user_can('manage_options') && isset($_GET['action'])) {
			switch($_GET['action']) {
				case 'opd-download':
					$id = intval($_GET["id"]);
					$file_details = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."sad_files WHERE id = '".$id."' AND deleted = '0'", ARRAY_A);
					if (empty($file_details)) {
						header('Location: '.admin_url('admin.php').'?page=opd');
						exit;
					}
					$this->download($file_details['source'], $file_details['filename'], admin_url('admin.php').'?page=opd');
					exit;
					break;
				case 'opd-add-link':
					$id = intval($_GET["id"]);
					$file_details = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."sad_files WHERE id = '".$id."' AND deleted = '0'", ARRAY_A);
					if (empty($file_details)) {
						header('Location: '.admin_url('admin.php').'?page=opd');
						die();
					}
					$secret_key = $this->random_string(24);
					if (defined('UAP_CORE')) {
						global $options;
						if (is_array($options) && array_key_exists['login']) {
							$name = $options['login'];
							$email = $options['login'];
						} else {
							$name = 'admin';
							$email = 'admin';
						}
					} else {
						$current_user = wp_get_current_user();
						$name = $current_user->user_login;
						$email = $current_user->user_email;
					}
					
					$sql = "INSERT INTO ".$wpdb->prefix."sad_users (
						file_id, name, email, url, source, secret_key, downloads, registered, deleted) VALUES (
						'".esc_sql($id)."',
						'".esc_sql($name)."',
						'".esc_sql($email)."',
						'".esc_sql($file_details['filename'])."',
						'".esc_sql($file_details['source'])."',
						'".esc_sql($secret_key)."',
						'0', '".time()."', '0'
					)";
					$wpdb->query($sql);
					header('Location: '.admin_url('admin.php').'?page=opd-users');
					exit;
					break;
				case 'opd-delete':
					$id = intval($_GET["id"]);
					$file_details = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."sad_files WHERE id = '".$id."' AND deleted = '0'", ARRAY_A);
					if (empty($file_details)) {
						header('Location: '.admin_url('admin.php').'?page=opd');
						die();
					}
					$sql = "UPDATE ".$wpdb->prefix."sad_files SET deleted = '1' WHERE id = '".$id."'";
					if ($wpdb->query($sql) !== false) {
						header('Location: '.admin_url('admin.php').'?page=opd&deleted=1');
					} else {
						header('Location: '.admin_url('admin.php').'?page=opd');
					}
					exit;
					break;
				case 'opd-delete-record':
					$id = intval($_GET["id"]);
					$user_details = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."sad_users WHERE id = '".$id."' AND deleted = '0'", ARRAY_A);
					if (intval($user_details["id"]) == 0) {
						header('Location: '.admin_url('admin.php').'?page=opd-users');
						die();
					}
					$sql = "UPDATE ".$wpdb->prefix."sad_users SET deleted = '1' WHERE id = '".$id."'";
					if ($wpdb->query($sql) !== false) {
						header('Location: '.admin_url('admin.php').'?page=opd-users&deleted=1');
					} else {
						header('Location: '.admin_url('admin.php').'?page=opd-users');
					}
					exit;
					break;
				case 'opd-csv':
					$rows = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."sad_users WHERE deleted = '0' ORDER BY registered DESC", ARRAY_A);
					if (sizeof($rows) > 0) {
						if (strstr($_SERVER["HTTP_USER_AGENT"],"MSIE")) {
							header("Pragma: public");
							header("Expires: 0");
							header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
							header("Content-type: application-download");
							header("Content-Disposition: attachment; filename=\"emails.csv\"");
							header("Content-Transfer-Encoding: binary");
						} else {
							header("Content-type: application-download");
							header("Content-Disposition: attachment; filename=\"emails.csv\"");
						}
						$separator = $this->options['csv_separator'];
						if ($separator == 'tab') $separator = "\t";
						echo '"Name"'.$separator.'"E-Mail"'.$separator.'"Source"'.$separator.'"File"'.$separator.'"Download URL"'.$separator.'"Downloads"'.$separator.'"Registered"'."\r\n";
						foreach ($rows as $row) {
							switch ($row['source']) {
								case 'media-library':
									$source = 'Media Library';
									$attachment = get_post(intval($row['url']), ARRAY_A);
									if (is_array($attachment) && array_key_exists('post_type', $attachment) && $attachment['post_type'] == 'attachment') {
										$file = $attachment['post_title'];
									} else $file = 'not found';
									break;
								case 'amazon-s3':
									$source = 'Amazon S3';
									$file = $row['url'];
									break;
								case 'file':
									$source = 'File';
									$file = $row['url'];
									break;
								default:
									$source = 'URL';
									$file = $row['url'];
									break;
							}
							$temp_url = rtrim(get_bloginfo('url'), '/');
							$temp_url .= (strpos($temp_url, '?') == false ? '/?' : '&').'opd='.$row['secret_key'];
							echo '"'.str_replace('"', '', $row["name"]).'"'.$separator.'"'.str_replace('"', "", $row["email"]).'"'.$separator.'"'.str_replace('"', "", $source).'"'.$separator.'"'.str_replace('"', "", $file).'"'.$separator.'"'.str_replace('"', "", $temp_url).'"'.$separator.'"'.str_replace('"', "", $row["downloads"]).'"'.$separator.'"'.date("Y-m-d H:i:s", $row["registered"]).'"'."\r\n";
						}
						die();
		            }
		            header("Location: ".get_bloginfo('wpurl')."/wp-admin/admin.php?page=opd");
					die();
					break;
				case 'opd-deleteall':
					$sql = "UPDATE ".$wpdb->prefix."sad_users SET deleted = '1' WHERE deleted = '0'";
					if ($wpdb->query($sql) !== false) {
						header('Location: '.admin_url('admin.php').'?page=opd-users&deleted=1');
					} else {
						header('Location: '.admin_url('admin.php').'?page=opd-users');
					}
					die();
					break;
				default:
					break;
			}
		}
	}

	function front_header() {
		global $post, $wpdb;
		$css = $this->front_css();
		echo $css.'
		<script>
			var opd_ajax_url = "'.admin_url('admin-ajax.php').'";
			var opd_ga_tracking = "'.$this->options['ga_tracking'].'";
		</script>';
	}
	
	function front_css() {
		$from = $this->get_rgb($this->options['button_color']);
		$total = $from['r']+$from['g']+$from['b'];
		if ($total == 0) $total = 1;
		$to = array();
		$to['r'] = max(0, $from['r']-intval(48*$from['r']/$total));
		$to['g'] = max(0, $from['g']-intval(48*$from['g']/$total));
		$to['b'] = max(0, $from['b']-intval(48*$from['b']/$total));
		$to_color = '#'.($to['r'] < 16 ? '0' : '').dechex($to['r']).($to['g'] < 16 ? '0' : '').dechex($to['g']).($to['b'] < 16 ? '0' : '').dechex($to['b']);
		$from_color = $this->options['button_color'];
		if (!empty($this->options['input_background_color'])) $bg_color = $this->get_rgb($this->options['input_background_color']);
		return '
		<style>
			.opd-form, .opd-info {background-color: '.(empty($this->options['box_color']) ? 'transparent' : $this->options['box_color']).' !important; border-color: '.(empty($this->options['box_border_color']) ? 'transparent' : $this->options['box_border_color']).' !important;'.(empty($this->options['box_font_color']) ? '' : ' color: '.$this->options['box_font_color'].' !important;').' font-size: '.intval($this->options['box_font_size']).'px !important;}
			.opd-form a, .opd-info a, .opd-form p, .opd-info p {'.(empty($this->options['box_font_color']) ? '' : ' color: '.$this->options['box_font_color']).' !important; font-size: '.intval($this->options['box_font_size']).'px !important;}
			.opd-form a, .opd-info a {'.(empty($this->options['box_font_color']) ? '' : ' color: '.$this->options['box_font_color']).' !important; text-decoration: underline !important;}
			.opd-submit, .opd-submit:visited {background-color: '.$from_color.' !important; border-color: '.$from_color.' !important; color: '.$this->options['button_font_color'].' !important; font-size: '.intval($this->options['button_font_size']).'px !important; text-decoration: none !important;}
			.opd-submit:hover, .opd-submit:active {background-color: '.$to_color.' !important; border-color: '.$to_color.' !important; color: '.$this->options['button_font_color'].' !important; font-size: '.intval($this->options['button_font_size']).'px !important; text-decoration: none !important;}
			.opd-checkbox, .opd-terms, .opd-input, .opd-input:hover, .opd-input:active, .opd-input:focus{border-color:'.(empty($this->options['input_border_color']) ? 'transparent' : $this->options['input_border_color']).' !important; background-color:'.(empty($this->options['input_background_color']) ? 'transparent' : $this->options['input_background_color']).' !important; background-color:'.(empty($this->options['input_background_color']) ? 'transparent' : 'rgba('.$bg_color['r'].','.$bg_color['g'].','.$bg_color['b'].','.floatval($this->options['input_background_opacity'])).') !important;'.(empty($this->options['input_font_color']) ? '' : ' color: '.$this->options['input_font_color'].' !important;').' font-size: '.intval($this->options['input_font_size']).'px !important;}
			div.opd-form-col div {'.(empty($this->options['input_font_color']) ? '' : ' color: '.$this->options['input_font_color'].' !important;').'font-size: '.intval($this->options['input_font_size']).'px !important;}
		</style>';
	}
	
	function shortcode_sdfile_handler($_atts) {
		global $post, $wpdb, $current_user;
		$form = '';
		if (isset($_atts["width"])) $width = intval($_atts["width"]);
		if (isset($width) && $width < 100) unset($width);
		if (isset($_atts["title"])) $intro = do_shortcode(trim($_atts["title"]));
		else $intro = do_shortcode(trim($this->options['intro']));
		if (strlen($intro) > 0) $intro = '<div class="opd-form-row">'.$intro.'</div>';
		if (isset($_atts['redirect'])) {
			$redirect = $_atts['redirect'];
			if (!preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $redirect) || strlen($redirect) == 0) $redirect = '';
		} else $redirect = '';

		$source = '';
		$file = '';
		if (array_key_exists('id', $_atts)) {
			$attachment = get_post(intval($_atts['id']), ARRAY_A);
			if (is_array($attachment) && array_key_exists('post_type', $attachment) && $attachment['post_type'] == 'attachment') {
				$source = 'media-library';
				$file = intval($_atts['id']);
			}
		} else if (array_key_exists('url', $_atts)) {
			$source = 'url';
			$file = $_atts['url'];
		} else if (array_key_exists('s3', $_atts)) {
			if (strlen($this->options['amazon_access_key']) != 0 && strlen($this->options['amazon_secret_key']) != 0 && strlen($this->options['amazon_bucket']) != 0) {
				$source = 'amazon-s3';
				$file = $_atts['s3'];
			}
		}
		if (empty($source) || empty($file)) {
			$content = '
		<div class="opd-container"'.(!empty($width) ? ' style="width: '.$width.'px;"' : '').'>
			<div class="opd-box">
				<div class="opd-form" style="text-align: center;">
					'.__('File is not available!', 'opd').'
				</div>
			</div>
		</div>';
			return $content;
		}
			
		$gdpr_html = '';
		if ($this->options['gdpr_enable'] == 'on') {
			$gdpr_id = $this->random_string(8);
			$checkbox_html = '<div class="opd-checkbox"><input class="opd-input" type="checkbox" id="'.$gdpr_id.'" name="gdpr" value="off" onclick="jQuery(this).parent().removeClass(\'opd-error\');"><label for="'.$gdpr_id.'"></label></div>';
			preg_match("'{(.*?)}'si", $this->options['gdpr_title'], $match);
			$local_terms_title = '';
			if ($match) $local_terms_title = $match[1];
			if (strlen($local_terms_title) > 0) {
				$terms = esc_html($this->options['terms']);
				$terms = str_replace("\n", "<br />", $terms);
				$terms = str_replace("\r", "", $terms);
				$gdpr_title = str_replace('{'.$local_terms_title.'}', '<a href="#" onclick="jQuery(this).parent().find(\'.opd-terms-container\').slideToggle(300); return false;">'.$local_terms_title.'</a>', $this->options['gdpr_title']);
				$gdpr_html = '
					<div class="opd-form-row">
						<div class="opd-terms-container opd-hide">
							<div class="opd-terms">'.$terms.'</div>
						</div>
						'.$checkbox_html.$gdpr_title.'
					</div>';
			} else {
				$gdpr_html = '
					<div class="opd-form-row">
					'.$checkbox_html.$this->options['gdpr_title'].'
					</div>';
			}
		}
				
			$form = '
		<div class="opd-container"'.(!empty($width) ? ' style="width: '.$width.'px;"' : '').'>
			<div class="opd-box">
				<div class="opd-form">
					'.$intro.'
					<div class="opd-form-row">
						'.($this->options['disable_name'] == 'on' ? '
						<div class="opd-form-col opd-fw opd-form-col-right">
							<div>
								<input required="required" class="opd-input opd-fw" type="email" name="email" placeholder="'.esc_html($this->options['placeholder_email']).'" value="'.esc_html($this->options['placeholder_email']).'" onfocus="jQuery(this).parent().removeClass(\'opd-error\'); if (this.value == \''.esc_html($this->options['placeholder_email']).'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.esc_html($this->options['placeholder_email']).'\';}" title="'.esc_html($this->options['placeholder_email']).'" />
								<i class="opd-fa opd-fa-mail-alt"></i>
							</div>
						</div>' : '
						<div class="opd-form-col opd-50">
							<div>
								<input required="required" class="opd-input opd-fw" type="text" name="name" placeholder="'.esc_html($this->options['placeholder_name']).'" value="'.esc_html($this->options['placeholder_name']).'" onfocus="jQuery(this).parent().removeClass(\'opd-error\'); if (this.value == \''.esc_html($this->options['placeholder_name']).'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.esc_html($this->options['placeholder_name']).'\';}" title="'.esc_html($this->options['placeholder_name']).'" />
								<i class="opd-fa opd-fa-user"></i>
							</div>
						</div>
						<div class="opd-form-col opd-50 opd-form-col-right">
							<div>
								<input required="required" class="opd-input opd-fw" type="email" name="email" placeholder="'.esc_html($this->options['placeholder_email']).'" value="'.esc_html($this->options['placeholder_email']).'" onfocus="jQuery(this).parent().removeClass(\'opd-error\'); if (this.value == \''.esc_html($this->options['placeholder_email']).'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.esc_html($this->options['placeholder_email']).'\';}" title="'.esc_html($this->options['placeholder_email']).'" />
								<i class="opd-fa opd-fa-mail-alt"></i>
							</div>
						</div>').'
					</div>
					'.$gdpr_html.'
					<div>
						<input type="hidden" class="opd-redirect" value="'.esc_html($redirect).'" />
						<input type="hidden" class="opd-input" name="source" value="'.esc_html($source).'" />
						<input type="hidden" class="opd-input" name="file" value="'.esc_html($this->encode_url($file)).'" />
						<span class="opd-submit" onclick=\'return opd_submit(this);\'><i class="opd-fa opd-fa-ok"></i>'.esc_html($this->options['button_label']).'</span>
					</div>
				</div>
				<div class="opd-message"></div>
			</div>
		</div>';				
		return $form;
	}

	function shortcode_opd_handler($_atts) {
		global $wpdb;
		$form = '';
		$width = null;
		if (array_key_exists('width', $_atts)) $width = intval($_atts["width"]);
		if (empty($width) || $width < 100) $width = null;
		$redirect = null;
		if (array_key_exists('redirect', $_atts) && preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $_atts['redirect']) && !empty($_atts['redirect'])) {
			$redirect = $_atts['redirect'];
		}

		$file_found = false;
		if (array_key_exists('id', $_atts)) {
			$id = intval($_atts["id"]);
			$file_details = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."sad_files WHERE id = '".$id."' AND deleted = '0'", ARRAY_A);
			if (!empty($file_details)) {
				$file_found = true;
			}
		}
		if (!$file_found) {
			$content = '
		<div class="opd-container"'.(!empty($width) ? ' style="max-width: '.$width.'px;"' : '').'>
			<div class="opd-box">
				<div class="opd-form" style="text-align: center;">
					'.__('File is currently not available.', 'opd').'
				</div>
			</div>
		</div>';
			return $content;
		}

		if (!empty($file_details["intro"])) $intro = do_shortcode($file_details["intro"]);
		else $intro = do_shortcode(trim($this->options['intro']));
		if (!empty($intro)) $intro = '<div class="opd-form-row">'.$intro.'</div>';

		$gdpr_html = '';
		if ($this->options['gdpr_enable'] == 'on') {
			$gdpr_id = $this->random_string(8);
			$checkbox_html = '<div class="opd-checkbox"><input class="opd-input" type="checkbox" id="'.$gdpr_id.'" name="gdpr" value="off" onclick="jQuery(this).parent().removeClass(\'opd-error\');"><label for="'.$gdpr_id.'"></label></div>';
			preg_match("'{(.*?)}'si", $this->options['gdpr_title'], $match);
			$local_terms_title = '';
			if ($match) $local_terms_title = $match[1];
			if (strlen($local_terms_title) > 0) {
				$terms = esc_html($this->options['terms']);
				$terms = str_replace("\n", "<br />", $terms);
				$terms = str_replace("\r", "", $terms);
				$gdpr_title = str_replace('{'.$local_terms_title.'}', '<a href="#" onclick="jQuery(this).parent().find(\'.opd-terms-container\').slideToggle(300); return false;">'.$local_terms_title.'</a>', $this->options['gdpr_title']);
				$gdpr_html = '
					<div class="opd-form-row">
						<div class="opd-terms-container opd-hide">
							<div class="opd-terms">'.$terms.'</div>
						</div>
						'.$checkbox_html.$gdpr_title.'
					</div>';
			} else {
				$gdpr_html = '
					<div class="opd-form-row">
					'.$checkbox_html.$this->options['gdpr_title'].'
					</div>';
			}
		}
				
		$form = '
		<div class="opd-container"'.(!empty($width) ? ' style="max-width: '.$width.'px;"' : '').'>
			<div class="opd-box">
				<div class="opd-form">
					'.$intro.'
					<div class="opd-form-row">
						'.($this->options['disable_name'] == 'on' ? '
						<div class="opd-form-col opd-fw opd-form-col-right">
							<div>
								<input required="required" class="opd-input opd-fw" type="email" name="email" placeholder="'.esc_html($this->options['placeholder_email']).'" value="'.esc_html($this->options['placeholder_email']).'" onfocus="jQuery(this).parent().removeClass(\'opd-error\'); if (this.value == \''.esc_html($this->options['placeholder_email']).'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.esc_html($this->options['placeholder_email']).'\';}" title="'.esc_html($this->options['placeholder_email']).'" />
								<i class="opd-fa opd-fa-mail-alt"></i>
							</div>
						</div>' : '
						<div class="opd-form-col opd-50">
							<div>
								<input required="required" class="opd-input opd-fw" type="text" name="name" placeholder="'.esc_html($this->options['placeholder_name']).'" value="'.esc_html($this->options['placeholder_name']).'" onfocus="jQuery(this).parent().removeClass(\'opd-error\'); if (this.value == \''.esc_html($this->options['placeholder_name']).'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.esc_html($this->options['placeholder_name']).'\';}" title="'.esc_html($this->options['placeholder_name']).'" />
								<i class="opd-fa opd-fa-user"></i>
							</div>
						</div>
						<div class="opd-form-col opd-50 opd-form-col-right">
							<div>
								<input required="required" class="opd-input opd-fw" type="email" name="email" placeholder="'.esc_html($this->options['placeholder_email']).'" value="'.esc_html($this->options['placeholder_email']).'" onfocus="jQuery(this).parent().removeClass(\'opd-error\'); if (this.value == \''.esc_html($this->options['placeholder_email']).'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.esc_html($this->options['placeholder_email']).'\';}" title="'.esc_html($this->options['placeholder_email']).'" />
								<i class="opd-fa opd-fa-mail-alt"></i>
							</div>
						</div>').'
					</div>
					'.$gdpr_html.'
					<div>
						<input type="hidden" class="opd-redirect" value="'.esc_html($redirect).'" />
						<input type="hidden" class="opd-input" name="id" value="'.esc_html($file_details['id']).'" />
						<span class="opd-submit" onclick=\'return opd_submit(this);\'><i class="opd-fa opd-fa-ok"></i>'.esc_html($this->options['button_label']).'</span>
					</div>
				</div>
				<div class="opd-message"></div>
			</div>
		</div>';				
		return $form;
	}

	function front_submit() {
		global $wpdb;
		$callback = '';
		if (array_key_exists('callback', $_REQUEST)) {
			header("Content-type: text/javascript");
			$callback = preg_replace('/[^a-zA-Z0-9_]/', '', $_REQUEST['callback']);
		}

		$email = base64_decode(trim(stripslashes($_REQUEST['opd-email'])));
		$errors = array();
		if ($this->options['disable_name'] != 'on') {
			$name = base64_decode(trim(stripslashes($_REQUEST['opd-name'])));
			if ($name == '' || $name == $this->options['placeholder_name']) {
				$errors['name'] = 'ERROR';
			}
		} else $name = '';
		
		if ($email == '' || !preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,19})$/i", $email)) {
			$errors['email'] = 'ERROR';
		} else {
			if ($this->options['email_validation'] == 'on') {
				$email_parts = explode('@',$email);
				if(checkdnsrr($email_parts[1], 'MX')) {
				} else $errors['email'] = 'ERROR';
			}
		}
		if ($this->options['gdpr_enable'] == 'on') {
			$gdpr = base64_decode(trim(stripslashes($_REQUEST['opd-gdpr'])));
			if ($gdpr != 'on') $errors['gdpr'] = 'ERROR';
		}
		$file_id = 0;
		$source = '';
		$file = '';
		$file_options = $this->default_file_options;
		if (array_key_exists("opd-id", $_REQUEST)) {
			$id = intval(base64_decode(trim(stripslashes($_REQUEST["opd-id"]))));
			$file_details = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."sad_files WHERE id = '".$id."' AND deleted = '0'", ARRAY_A);
			if (!empty($file_details)) {
				if (array_key_exists('options', $file_details)) {
					$file_options = json_decode($file_details['options'], true);
					if (empty($file_options)) $file_options = $this->default_file_options;
				}
				$file = $file_details['filename'];
				$source = $file_details['source'];
				$file_id = $file_details['id'];
			}
		} else if (array_key_exists("opd-source", $_REQUEST) && array_key_exists("opd-file", $_REQUEST)) {
			$source = base64_decode(trim(stripslashes($_REQUEST['opd-source'])));
			$file = $this->decode_url(base64_decode(trim(stripslashes($_REQUEST['opd-file']))));
		}

		if (empty($file) || !in_array($source, array('amazon-s3', 'url', 'media-library', 'file'))) {
			$errors['message'] = '
		<div class="opd-container">
			<div class="opd-box">
				<div class="opd-form" style="text-align: center;">
					'.__('File is not available!', 'opd').'
				</div>
			</div>
		</div>';
		}
		
		if (!empty($errors)) {
			$errors['status'] = 'ERROR';
			if (!empty($callback)) echo $callback.'('.json_encode($errors).')';
			else echo json_encode($errors);
			exit;
		} else {
			$secret_key = $this->random_string(24);
			$sql = "INSERT INTO ".$wpdb->prefix."sad_users (
				file_id, name, email, url, source, secret_key, downloads, registered, deleted) VALUES (
				'".esc_sql($file_id)."',
				'".esc_sql($name)."',
				'".esc_sql($email)."',
				'".esc_sql($file)."',
				'".esc_sql($source)."',
				'".esc_sql($secret_key)."',
				'0', '".time()."', '0'
			)";
			$wpdb->query($sql);
			if (empty($name)) $name = substr($email, 0, strpos($email, '@'));
			$subscriber = array('name' => $name, 'email' => $email);
			if ($this->options['mailchimp_enable'] == 'on') {
				$this->mailchimp_subscribe($subscriber);
			}
			if ($this->options['icontact_enable'] == 'on') {
				$this->icontact_addcontact($name, $email);
			}
			if ($this->options['campaignmonitor_enable'] == 'on') {
				$options['EmailAddress'] = $email;
				$options['Name'] = $name;
				$options['Resubscribe'] = 'true';
				$options['RestartSubscriptionBasedAutoresponders'] = 'true';
				$post = json_encode($options);

				$curl = curl_init('http://api.createsend.com/api/v3/subscribers/'.urlencode($this->options['campaignmonitor_list_id']).'.json');
				curl_setopt($curl, CURLOPT_POST, 1);
				curl_setopt($curl, CURLOPT_POSTFIELDS, $post);
				
				$header = array(
					'Content-Type: application/json',
					'Content-Length: '.strlen($post),
					'Authorization: Basic '.base64_encode($this->options['campaignmonitor_api_key'])
					);

				//curl_setopt($curl, CURLOPT_PORT, 443);
				curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
				curl_setopt($curl, CURLOPT_TIMEOUT, 10);
				curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC ) ;
				//curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 1); // verify certificate
				//curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2); // check existence of CN and verify that it matches hostname
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
				curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
					
				$response = curl_exec($curl);
				curl_close($curl);
			}
			if ($this->options['getresponse_enable'] == 'on') {
				$this->getresponse_subscribe($subscriber);
			}
			if ($this->options['aweber_access_secret']) {
				if ($this->options['aweber_enable'] == 'on') {
					$account = null;
					if (!class_exists('AWeberAPI')) {
						require_once(dirname(__FILE__).'/aweber_api/aweber_api.php');
					}
					try {
						$aweber = new AWeberAPI($this->options['aweber_consumer_key'], $this->options['aweber_consumer_secret']);
						$account = $aweber->getAccount($this->options['aweber_access_key'], $this->options['aweber_access_secret']);
						$subscribers = $account->loadFromUrl('/accounts/' . $account->id . '/lists/' . $this->options['aweber_listid'] . '/subscribers');
						$subscribers->create(array(
							'email' => $email,
							'ip_address' => $_SERVER['REMOTE_ADDR'],
							'name' => $name,
							'ad_tracking' => 'Opt-In Panel',
						));
					} catch (Exception $e) {
						$account = null;
					}
				}
			}
			if ($this->options['madmimi_enable'] == 'on') {
				$request = http_build_query(array(
					'email' => $email,
					'first_name' => $name,
					'last_name' => '',
					'username' => $this->options['madmimi_login'],
					'api_key' => $this->options['madmimi_api_key']
				));

				$curl = curl_init('http://api.madmimi.com/audience_lists/'.$this->options['madmimi_list_id'].'/add');
				curl_setopt($curl, CURLOPT_POST, 1);
				curl_setopt($curl, CURLOPT_POSTFIELDS, $request);

				curl_setopt($curl, CURLOPT_TIMEOUT, 20);
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
				curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
				curl_setopt($curl, CURLOPT_HEADER, 0);
									
				$response = curl_exec($curl);
				curl_close($curl);
			}
			if ($this->options['sendy_enable'] == 'on') {
				$request = http_build_query(array(
					'email' => $email,
					'name' => $name,
					'list' => $this->options['sendy_listid'],
					'boolean' => 'true'
				));

				$this->options['sendy_url'] = rtrim($this->options['sendy_url'], '/');
				$curl = curl_init($this->options['sendy_url'].'/subscribe');
				curl_setopt($curl, CURLOPT_POST, 1);
				curl_setopt($curl, CURLOPT_POSTFIELDS, $request);

				curl_setopt($curl, CURLOPT_TIMEOUT, 20);
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
				curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
				curl_setopt($curl, CURLOPT_HEADER, 0);
									
				$response = curl_exec($curl);
				curl_close($curl);
			}
			if ($this->options['benchmark_enable'] == 'on') {
				$request = http_build_query(array(
					'contacts' => array(
						'email' => $email,
						'firstname' => $name,
						'lastname' => ''),
					'optin' => ($this->options['benchmark_double'] == 'on' ? 1 : 0),
					'listID' => $this->options['benchmark_list_id'],
					'token' => $this->options['benchmark_api_key']
				));

				$curl = curl_init('http://www.benchmarkemail.com/api/1.0/?output=php&method=listAddContacts');
				curl_setopt($curl, CURLOPT_POST, 1);
				curl_setopt($curl, CURLOPT_POSTFIELDS, $request);

				curl_setopt($curl, CURLOPT_TIMEOUT, 20);
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
				curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
				curl_setopt($curl, CURLOPT_HEADER, 0);
									
				$response = curl_exec($curl);
				curl_close($curl);
			}
			if (function_exists('mailster')) {
				if ($this->options['mymail_enable'] == 'on') {
					$list = mailster('lists')->get($this->options['mymail_listid']);
					if (!empty($list)) {
						try {
							if ($this->options['mymail_double'] == "on") $double = true;
							else $double = false;
							$entry = array(
								'firstname' => $name,
								'email' => $email,
								'status' => $double ? 0 : 1,
								'ip' => $_SERVER['REMOTE_ADDR'],
								'signup_ip' => $_SERVER['REMOTE_ADDR'],
								'referer' => $_SERVER['HTTP_REFERER'],
								'signup' =>time()
							);
							$subscriber_id = mailster('subscribers')->add($entry, true);
							if (is_wp_error( $subscriber_id )) return;
							$result = mailster('subscribers')->assign_lists($subscriber_id, array($list->ID));
						} catch (Exception $e) {
						}
					}
				}
			}
			$domain_parts = explode('.', $_SERVER["HTTP_HOST"]);
			if (sizeof($domain_parts) > 2) $domain = '.'.$domain_parts[sizeof($domain_parts)-2].'.'.$domain_parts[sizeof($domain_parts)-1];
			else $domain = '.'.$_SERVER["HTTP_HOST"];

			$encrypted_url = defined('UAP_CORE') ? admin_url('do.php') : rtrim(get_bloginfo('url'), '/').'/';
			$encrypted_url .= (strpos($encrypted_url, '?') == false ? '?' : '&').'opd='.$secret_key;
			
			if ($this->options['thanksgiving_enable'] == 'on' || $file_options['welcome-email-custom'] == 'on') {
				$tags = array("{download_link}", "{name}", "{e-mail}", "{email}");
				$vals = array($encrypted_url, $name, $email, $email);
				if ($file_options['welcome-email-custom'] == 'on') {
					$subject = $file_options['welcome-email-subject'];
					$body = $file_options['welcome-email-body'];
				} else {
					$subject = $this->options['thanksgiving_email_subject'];
					$body = $this->options['thanksgiving_email_body'];
				}
				$body = str_replace($tags, $vals, $body);
				if (strpos(strtolower($body), '<html') === false) $body = str_replace(array("\n", "\r"), array("<br />", ""), $body);
				$mail_headers = "Content-Type: text/html; charset=utf-8\r\n";
				$mail_headers .= "From: ".$this->options['from_name']." <".$this->options['from_email'].">\r\n";
				$mail_headers .= "X-Mailer: PHP/".phpversion()."\r\n";
				wp_mail($email, $subject, $body, $mail_headers);
			}

			if ($this->options['mail_enable'] == 'on') {
				$tags = array("{download_link}", "{name}", "{e-mail}", "{email}", "{ip}", "{url}", "{user-agent}");
				$vals = array($encrypted_url, $name, $email, $email, $_SERVER['REMOTE_ADDR'], $_SERVER['HTTP_REFERER'], $_SERVER['HTTP_USER_AGENT']);
				$body = str_replace($tags, $vals, $this->options['mail_message']);
				if (strpos(strtolower($body), '<html') === false) $body = str_replace(array("\n", "\r"), array("<br />", ""), $body);
				$mail_headers = "Content-Type: text/html; charset=utf-8\r\n";
				$mail_headers .= "Reply-To: ".(empty($name) ? esc_html($email) : esc_html($name))." <".esc_html($email).">\r\n";
				if ($this->options['mail_from'] == 'on') {
					$mail_headers .= "From: ".(empty($name) ? esc_html($email) : esc_html($name))." <".esc_html($email).">\r\n";
				} else {
					$mail_headers .= "From: ".(empty($this->options['from_name']) ? esc_html($this->options['from_email']) : esc_html($this->options['from_name']))." <".esc_html($this->options['from_email']).">\r\n";
				}
				$mail_emails = explode(',', $this->options['mail_email']);
				foreach ($mail_emails as $mail_email) {
					$mail_email = trim($mail_email);
					if (!empty($mail_email)) {
						if (preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,19})$/i", $mail_email)) {
							wp_mail($mail_email, $this->options['mail_subject'], $body, $mail_headers);					
						}
					}
				}
			}

			$return = array();
			$return['status'] = 'OK';
			$return['message'] = '<div class="opd-info" style="text-align: center;">'.esc_html(str_replace(array('{name}', '{email}'), array($name, $email),$this->options['thanks_message'])).'</div>';
			if (!empty($callback)) echo $callback.'('.json_encode($return).')';
			else echo json_encode($return);
		}
		exit;
	}

	function get_rgb($_color) {
		if (strlen($_color) != 7 && strlen($_color) != 4) return false;
		$color = preg_replace('/[^#a-fA-F0-9]/', '', $_color);
		if (strlen($color) != strlen($_color)) return false;
		if (strlen($color) == 7) list($r, $g, $b) = array($color[1].$color[2], $color[3].$color[4], $color[5].$color[6]);
		else list($r, $g, $b) = array($color[1].$color[1], $color[2].$color[2], $color[3].$color[3]);
		return array("r" => hexdec($r), "g" => hexdec($g), "b" => hexdec($b));
	}

	function madmimi_getlists($_login, $_key) {
		$curl = curl_init('http://api.madmimi.com/audience_lists/lists.json?'.http_build_query(array('username' => $_login, 'api_key' => $_key)));
		curl_setopt($curl, CURLOPT_POST, 0);
		curl_setopt($curl, CURLOPT_TIMEOUT, 10);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_HEADER, 0);
														
		$response = curl_exec($curl);
											
		if (curl_error($curl)) return array();
		$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		if ($httpCode != '200') return array();
		curl_close($curl);
											
		$result = json_decode($response, true);
		if(!$result) return array();
		$lists = array();
		foreach ($result as $key => $value) {
			$lists[$value['id']] = $value['name'];
		}
		return $lists;
	}

	function benchmark_getlists($_key) {
		$request = http_build_query(array(
			'token' => $_key
		));

		$curl = curl_init('http://www.benchmarkemail.com/api/1.0/?output=php&method=listGet');
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $request);

		curl_setopt($curl, CURLOPT_TIMEOUT, 20);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_HEADER, 0);
								
		$response = curl_exec($curl);
		curl_close($curl);

		$result = unserialize($response);
		if (!is_array($result) || isset($result['error'])) return array();
		$lists = array();
		foreach ($result as $key => $value) {
			$lists[$value['id']] = $value['listname'];
		}
		return $lists;
	}

	function icontact_getlists() {
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/', null, 'accounts');
		if (!empty($data['errors'])) return array();
		$account = $data['response'][0];
		if (empty($account) || intval($account->enabled != 1)) return;
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/', null, 'clientfolders');
		if (!empty($data['errors'])) return array();
		$client = $data['response'][0];
		if (empty($client)) return array();
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/'.$client->clientFolderId.'/lists', array(), 'lists');
		if (!empty($data['errors'])) return array();
		if (!is_array($data['response'])) return array();
		$lists = array();
		foreach ($data['response'] as $list) {
			$lists[$list->listId] = $list->name;
		}
		return $lists;
	}

	function icontact_addcontact($name, $email) {
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/', null, 'accounts');
		if (!empty($data['errors'])) return;
		$account = $data['response'][0];
		if (empty($account) || intval($account->enabled != 1)) return;
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/', null, 'clientfolders');
		if (!empty($data['errors'])) return;
		$client = $data['response'][0];
		if (empty($client)) return;
		$contact['email'] = $email;
		$contact['firstName'] = $name;
		$contact['status'] = 'normal';
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/'.$client->clientFolderId.'/contacts', array($contact), 'contacts');
		if (!empty($data['errors'])) return;
		$contact = $data['response'][0];
		if (empty($contact)) return;
		$subscriber['contactId'] = $contact->contactId;
		$subscriber['listId'] = $this->options['icontact_listid'];
		$subscriber['status'] = 'normal';
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/'.$client->clientFolderId.'/subscriptions', array($subscriber), 'subscriptions');
	}

	function icontact_makecall($appid, $apiusername, $apipassword, $resource, $postdata = null, $returnkey = null) {
		$return = array();
		$url = "https://app.icontact.com/icp".$resource;
		$headers = array(
			'Except:', 
			'Accept:  application/json', 
			'Content-type:  application/json', 
			'Api-Version:  2.2',
			'Api-AppId:  '.$appid, 
			'Api-Username:  '.$apiusername, 
			'Api-Password:  '.$apipassword
		);
		$handle = curl_init();
		curl_setopt($handle, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($handle, CURLOPT_SSL_VERIFYPEER, false);
		if (!empty($postdata)) {
			curl_setopt($handle, CURLOPT_POST, true);
			curl_setopt($handle, CURLOPT_POSTFIELDS, json_encode($postdata));
		}
		curl_setopt($handle, CURLOPT_URL, $url);
		if (!$response_json = curl_exec($handle)) {
			$return['errors'][] = __('Unable to execute the cURL handle.', 'opd');
		}
		if (!$response = json_decode($response_json)) {
			$return['errors'][] = __('The iContact API did not return valid JSON.', 'opd');
		}
		curl_close($handle);
		if (!empty($response->errors)) {
			foreach ($response->errors as $error) {
				$return['errors'][] = $error;
			}
		}
		if (!empty($return['errors'])) return $return;
		if (empty($returnkey)) {
			$return['response'] = $response;
		} else {
			$return['response'] = $response->$returnkey;
		}
		return $return;
	}

	function page_switcher ($_urlbase, $_currentpage, $_totalpages) {
		$pageswitcher = "";
		if ($_totalpages > 1) {
			$pageswitcher = '<div class="tablenav bottom"><div class="tablenav-pages">'.__('Pages:', 'opd').' <span class="pagiation-links">';
			if (strpos($_urlbase,"?") !== false) $_urlbase .= "&amp;";
			else $_urlbase .= "?";
			if ($_currentpage == 1) $pageswitcher .= "<a class='page disabled'>1</a> ";
			else $pageswitcher .= " <a class='page' href='".$_urlbase."p=1'>1</a> ";

			$start = max($_currentpage-3, 2);
			$end = min(max($_currentpage+3,$start+6), $_totalpages-1);
			$start = max(min($start,$end-6), 2);
			if ($start > 2) $pageswitcher .= " <b>...</b> ";
			for ($i=$start; $i<=$end; $i++) {
				if ($_currentpage == $i) $pageswitcher .= " <a class='page disabled'>".$i."</a> ";
				else $pageswitcher .= " <a class='page' href='".$_urlbase."p=".$i."'>".$i."</a> ";
			}
			if ($end < $_totalpages-1) $pageswitcher .= " <b>...</b> ";

			if ($_currentpage == $_totalpages) $pageswitcher .= " <a class='page disabled'>".$_totalpages."</a> ";
			else $pageswitcher .= " <a class='page' href='".$_urlbase."p=".$_totalpages."'>".$_totalpages."</a> ";
			$pageswitcher .= "</span></div></div>";
		}
		return $pageswitcher;
	}
	function mailchimp_show_lists() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			$lists = array();
			if (!isset($_POST['opd_api_key']) || empty($_POST['opd_api_key'])) {
				$return_object = array();
				$return_object['status'] = 'OK';
				$return_object['html'] = '<div style="text-align: center; margin: 20px 0px;">'.__('Invalid API Key!', 'opd').'</div>';
				echo json_encode($return_object);
				exit;
			}
			$key = trim(stripslashes($_POST['opd_api_key']));
			
			$result = $this->mailchimp_connect($key, 'lists?count=100');
			
			if (is_array($result) && array_key_exists('total_items', $result)) {
				if (intval($result['total_items']) > 0) {
					foreach ($result['lists'] as $list) {
						if (is_array($list)) {
							if (array_key_exists('id', $list) && array_key_exists('name', $list)) {
								$lists[$list['id']] = $list['name'];
							}
						}
					}
				} else {
					$return_object = array();
					$return_object['status'] = 'OK';
					$return_object['html'] = '<div style="text-align: center; margin: 20px 0px;">'.__('No Lists found!', 'opd').'</div>';
					echo json_encode($return_object);
					exit;
				}
			} else {
				$return_object = array();
				$return_object['status'] = 'OK';
				$return_object['html'] = '<div style="text-align: center; margin: 20px 0px;">'.__('Invalid API Key!', 'opd').'</div>';
				echo json_encode($return_object);
				exit;
			}
			$list_html = '';
			if (!empty($lists)) {
				foreach ($lists as $id => $name) {
					$list_html .= '<a href="#" data-id="'.esc_html($id).'" data-title="'.esc_html($id).(!empty($name) ? ' | '.esc_html($name) : '').'" onclick="return opd_input_options_selected(this);">'.esc_html($id).(!empty($name) ? ' | '.esc_html($name) : '').'</a>';
				}
			} else $list_html .= '<div style="text-align: center; margin: 20px 0px;">'.__('No data found!', 'opd').'</div>';
			$return_object = array();
			$return_object['status'] = 'OK';
			$return_object['html'] = $list_html;
			$return_object['items'] = sizeof($lists);
			echo json_encode($return_object);
		}
		exit;
	}
	function mailchimp_subscribe($_subscriber) {
		if (empty($_subscriber['email'])) return;
		if ($this->options['mailchimp_enable'] == 'on') {
			$result = $this->mailchimp_connect($this->options['mailchimp_api_key'], 'lists/'.urlencode($this->options['mailchimp_list_id']).'/members/'.md5(strtolower($_subscriber['email'])));
			$status = '';
			if (array_key_exists('status', $result)) $status = $result['status'];
			if (array_key_exists('status', $result) && $result['status'] == 'pending') {
				$this->mailchimp_connect($this->options['mailchimp_api_key'], 'lists/'.urlencode($this->options['mailchimp_list_id']).'/members/'.md5(strtolower($_subscriber['email'])), array(), 'DELETE');
			}
			$data = array(
				'ip_signup' => $_SERVER['REMOTE_ADDR'],
				'email_address' => $_subscriber['email'],
				'status' => $this->options['mailchimp_double'] == 'on' ? (!empty($status) ? 'subscribed' : 'pending') : 'subscribed',
				'status_if_new' => $this->options['mailchimp_double'] == 'on' ? 'pending' : 'subscribed',
				'merge_fields' => array(
					'NAME' => $_subscriber['name'],
					'FNAME' => $_subscriber['name'],
					'LNAME' => $_subscriber['name']
				)
			);
			$result = $this->mailchimp_connect($this->options['mailchimp_api_key'], 'lists/'.urlencode($this->options['mailchimp_list_id']).'/members/'.md5(strtolower($_subscriber['email'])), $data, 'PUT');
		}
	}
	
	function mailchimp_connect($_api_key, $_path, $_data = array(), $_method = '') {
		$dc = "us1";
		if (strstr($_api_key, "-")) {
			list($key, $dc) = explode("-", $_api_key, 2);
			if (!$dc) $dc = "us1";
		}
		$headers = array(
			'Content-Type: application/json;charset=UTF-8',
			'Accept: application/json'
		);
		try {
			$url = 'https://'.$dc.'.api.mailchimp.com/3.0/'.ltrim($_path, '/');
			$curl = curl_init($url);
			curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
			curl_setopt($curl, CURLOPT_USERPWD, 'layered-popups:'.$_api_key);
			if (!empty($_data)) {
				curl_setopt($curl, CURLOPT_POST, true);
				curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($_data));
			}
			if (!empty($_method)) {
				curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $_method);
			}
			curl_setopt($curl, CURLOPT_TIMEOUT, 120);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($curl, CURLOPT_FORBID_REUSE, true);
			curl_setopt($curl, CURLOPT_FRESH_CONNECT, true);
			//curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			$response = curl_exec($curl);
			curl_close($curl);
			$result = json_decode($response, true);
		} catch (Exception $e) {
			$result = false;
		}
		return $result;
	}

	function getresponse_show_lists() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			$lists = array();
			if (!isset($_POST['opd_api_key']) || empty($_POST['opd_api_key'])) {
				$return_object = array();
				$return_object['status'] = 'OK';
				$return_object['html'] = '<div style="text-align: center; margin: 20px 0px;">'.__('Invalid API Key!', 'opd').'</div>';
				echo json_encode($return_object);
				exit;
			}
			$key = trim(stripslashes($_POST['opd_api_key']));
			
			$result = $this->getresponse_connect($key, 'campaigns?page=1&perPage=100');

			if (is_array($result) && !empty($result)) {
				if (array_key_exists('code', $result)) {
					$return_object = array();
					$return_object['status'] = 'OK';
					$return_object['html'] = '<div style="text-align: center; margin: 20px 0px;">'.esc_html($result['codeDescription']).'</div>';
					echo json_encode($return_object);
					exit;
				} else {
					foreach ($result as $campaign) {
						if (is_array($campaign)) {
							if (array_key_exists('campaignId', $campaign) && array_key_exists('name', $campaign)) {
								$lists[$campaign['campaignId']] = $campaign['name'];
							}
						}
					}
				}
			} else {
				$return_object = array();
				$return_object['status'] = 'OK';
				$return_object['html'] = '<div style="text-align: center; margin: 20px 0px;">'.__('Invalid API server response.', 'opd').'</div>';
				echo json_encode($return_object);
				exit;
			}
			$list_html = '';
			if (!empty($lists)) {
				foreach ($lists as $id => $name) {
					$list_html .= '<a href="#" data-id="'.esc_html($id).'" data-title="'.esc_html($id).(!empty($name) ? ' | '.esc_html($name) : '').'" onclick="return opd_input_options_selected(this);">'.esc_html($id).(!empty($name) ? ' | '.esc_html($name) : '').'</a>';
				}
			} else {
				$list_html .= '<div style="text-align: center; margin: 20px 0px;">'.__('No campaigns found.', 'opd').'</div>';
			}
			$return_object = array();
			$return_object['status'] = 'OK';
			$return_object['html'] = $list_html;
			$return_object['items'] = sizeof($lists);
			echo json_encode($return_object);
		}
		exit;
	}
	function getresponse_subscribe($_subscriber) {
		if (empty($_subscriber['email'])) return;
		if ($this->options['getresponse_enable'] == 'on') {
			$post_data = array(
				'campaign' => array('campaignId' => $this->options['getresponse_list_id']),
				'name' => $_subscriber['name'],
				'email' => $_subscriber['email'],
				'dayOfCycle' => 0,
				'ipAddress' => $_SERVER['REMOTE_ADDR']
			);
			$result = $this->getresponse_connect($this->options['getresponse_api_key'], 'contacts?query[email]='.$_subscriber['email']);
			if (empty($result)) {
				$result = $this->getresponse_connect($this->options['getresponse_api_key'], 'contacts', $post_data);
			} else {
				$contact_id = $result[0]['contactId'];
				$result = $this->getresponse_connect($this->options['getresponse_api_key'], 'contacts/'.$contact_id, $post_data);
			}
		}
	}
	
	function getresponse_connect($_api_key, $_path, $_data = array(), $_method = '') {
		$headers = array(
			'X-Auth-Token: api-key '.$_api_key,
			'Content-Type: application/json;charset=UTF-8',
			'Accept: application/json'
		);
		try {
			$url = 'https://api.getresponse.com/v3/'.ltrim($_path, '/');
			$curl = curl_init($url);
			curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
			if (!empty($_data)) {
				curl_setopt($curl, CURLOPT_POST, true);
				curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($_data));
			}
			if (!empty($_method)) {
				curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $_method);
			}
			curl_setopt($curl, CURLOPT_TIMEOUT, 20);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($curl, CURLOPT_FORBID_REUSE, true);
			curl_setopt($curl, CURLOPT_FRESH_CONNECT, true);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			$response = curl_exec($curl);
			curl_close($curl);
			$result = json_decode($response, true);
		} catch (Exception $e) {
			$result = false;
		}
		return $result;
	}


	function amazon_url($_access_key, $_secret_key, $_bucket, $_file, $_expires = 24) {
		$_expires = time() + intval($_expires)*3600;
		$_file = str_replace('%2F', '/', rawurlencode($_file = ltrim($_file, '/')));
		$signpath = '/'.$_bucket.'/'.$_file;
		$signsz = implode("\n", $pieces = array('GET', null, null, $_expires, $signpath));
		
		$blocksize = 64;
		if (strlen($_secret_key) > $blocksize) $_secret_key = pack('H*', sha1($_secret_key));
		$_secret_key = str_pad($_secret_key, $blocksize, chr(0x00));
		$ipad = str_repeat(chr(0x36), $blocksize);
		$opad = str_repeat(chr(0x5c), $blocksize);
		$hmac = pack('H*', sha1(($_secret_key ^ $opad) . pack( 'H*', sha1(($_secret_key ^ $ipad).$signsz))));
        $signature = base64_encode($hmac);
		
		$url = sprintf('http://%s.s3.amazonaws.com/%s', $_bucket, $_file);
		$qs = http_build_query($pieces = array(
			'AWSAccessKeyId' => $_access_key,
			'Expires' => $_expires,
			'Signature' => $signature,
		));
		return $url.'?'.$qs;
	}
	
	function encode_url($_url) {
		return base64_encode($_url);
	}

	function decode_url($_url) {
		return base64_decode($_url);
	}

	function personal_data_exporters($_exporters) {
		$_exporters['opd'] = array(
			'exporter_friendly_name' => __('Opt-In Downloads', 'opd'),
			'callback' => array(&$this, 'personal_data_exporter')
		);
		return $_exporters;
	}
	
	function personal_data_exporter($_email_address, $_page = 1) {
		global $wpdb;
		if (empty($_email_address)) {
			return array(
				'data' => array(),
				'done' => true
			);
		}
		$data_to_export = array();
		$rows = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."sad_users WHERE email = '".esc_sql($_email_address)."' ORDER BY registered DESC", ARRAY_A);
		foreach ($rows as $row) {
			$data = array(
				'group_id' => 'opd-log',
				'group_label' => __('Opt-In Downloads', 'opd'),
				'item_id' => 'opd-log-'.$row['id']
			);
			if (!empty($row['email'])) $data['data'][] = array('name' => __('Email', 'opd'), 'value' => $row['email']);
			if (!empty($row['name'])) $data['data'][] = array('name' => __('Name', 'opd'), 'value' => $row['name']);
			$temp_url = rtrim(get_bloginfo('url'), '/');
			$temp_url .= (strpos($temp_url, '?') == false ? '/?' : '&').'opd='.$row['secret_key'];
			if (!empty($row['secret_key'])) $data['data'][] = array('name' => __('Download Link', 'opd'), 'value' => $temp_url);
			switch ($row['source']) {
				case 'media-library':
					$attachment = get_post(intval($row['url']), ARRAY_A);
					if (is_array($attachment) && array_key_exists('post_type', $attachment) && $attachment['post_type'] == 'attachment') {
						$file = 'Media Library: '.$attachment['post_title'];
					} else $file = 'Media Library: not found';
					break;
				case 'amazon-s3':
					$file = 'Amazon S3: '.$row['url'];
					break;
				default:
					$file = 'URL: '.$row['url'];
					break;
			}
			$data['data'][] = array('name' => __('File', 'opd'), 'value' => $file);
			$data['data'][] = array('name' => __('Created', 'opd'), 'value' => date("Y-m-d H:i", $row['registered']));
			if ($row['deleted'] != 0) $data['data'][] = array('name' => __('Deleted', 'opd'), 'value' => 'yes');
			$data_to_export[] = $data;
		}
		return array(
			'data' => $data_to_export,
			'done' => true
		);
	}
	
	function personal_data_erasers($_erasers) {
		$_erasers['opd'] = array(
			'eraser_friendly_name' => __('Opt-In Downloads', 'opd'),
			'callback' => array(&$this, 'personal_data_eraser')
		);
		return $_erasers;
	}

	function personal_data_eraser($_email_address, $_page = 1) {
		global $wpdb;
		if (empty($_email_address)) {
			return array(
				'items_removed'  => false,
				'items_retained' => false,
				'messages'       => array(),
				'done'           => true,
			);
		}
		$tmp = $wpdb->get_row("SELECT COUNT(*) AS total FROM ".$wpdb->prefix."sad_users WHERE email = '".esc_sql($_email_address)."'", ARRAY_A);
		$total = $tmp["total"];
		$wpdb->query("DELETE FROM ".$wpdb->prefix."sad_users WHERE email = '".esc_sql($_email_address)."'");
		return array(
			'items_removed'  => $total,
			'items_retained' => false,
			'messages'       => array(),
			'done'           => true,
		);
	}

	function admin_modal_html() {
		return '
<div class="opd-modal-overlay"></div>
<div class="opd-modal">
	<div class="opd-modal-content">
		<div class="opd-modal-message"></div>
		<div class="opd-modal-buttons">
			<a class="opd-modal-button" id="opd-modal-button-ok" href="#" onclick="return false;"><i class="opd-fa opd-fa-ok"></i><label></label></a>
			<a class="opd-modal-button" id="opd-modal-button-cancel" href="#" onclick="return false;"><i class="opd-fa opd-fa-cancel"></i><label></label></a>
		</div>
	</div>
</div>';
	}

	function get_filename($_path, $_filename) {
		$filename = preg_replace('/[^a-zA-Z0-9\s\-\.\_]/', ' ', $_filename);
		$filename = preg_replace('/(\s\s)+/', ' ', $filename);
		$filename = trim($filename);
		$filename = preg_replace('/\s+/', '-', $filename);
		$filename = preg_replace('/\-+/', '-', $filename);
		if (strlen($filename) == 0) $filename = "file";
		else if ($filename[0] == ".") $filename = "file".$filename;
		while (file_exists($_path.$filename)) {
			$pos = strrpos($filename, ".");
			if ($pos !== false) {
				$ext = substr($filename, $pos);
				$filename = substr($filename, 0, $pos);
			} else {
				$ext = "";
			}
			$pos = strrpos($filename, "-");
			if ($pos !== false) {
				$suffix = substr($filename, $pos+1);
				if (ctype_digit($suffix)) {
					$suffix++;
					$filename = substr($filename, 0, $pos)."-".$suffix.$ext;
				} else {
					$filename = $filename."-1".$ext;
				}
			} else {
				$filename = $filename."-1".$ext;
			}
		}
		return $filename;
	}

	function remote_init() {
		global $wpdb;
		if (isset($_REQUEST['callback'])) {
			header("Content-type: text/javascript");
			$jsonp_callback = $_REQUEST['callback'];
		} else die("JSONP is not supported!");
		$return_data = array();
		$return_data['status'] = 'OK';
		$return_data['resources']['css'][] = plugins_url('/css/style.css?ver='.OPD_VERSION, __FILE__);
		$return_data['css'] = $this->front_css();
		$return_data['ga-tracking'] = $this->options['ga_tracking'];
		if (array_key_exists('ids', $_REQUEST)) {
			$items = explode(',', trim(stripslashes($_REQUEST['ids'])));
			if (sizeof($items) > 0) {
				foreach($items as $item) {
					$item = intval(trim($item));
					$atts = array('id' => $item);
					$return_data['forms'][] = $this->shortcode_opd_handler($atts);
				}
			}
		}
		echo $jsonp_callback.'('.json_encode($return_data).')';
		exit;
	}

	function download($_source, $_file, $_url) {
		global $wpdb;
		switch ($_source) {
			case 'media-library':
				if (defined('UAP_CORE')) {
					header('Location: '.$_url);
					exit;
				}
				$attachment_id = intval($_file);
				$attachment = get_post($attachment_id, ARRAY_A);
				if (is_array($attachment) && array_key_exists('post_type', $attachment) && $attachment['post_type'] == 'attachment') {
					if ($this->options['media_secure'] == 'on') {
						$filename = get_attached_file($attachment_id);
						if (!file_exists($filename) || !is_file($filename)) {
							header('Location: '.$_url);
							exit;
						}
						$filename_original = basename($filename);
						error_reporting(0);
						ob_start();
						if(!ini_get('safe_mode')) set_time_limit(0);
						ob_end_clean();
						if ($this->options['xsendfile'] == 'on') {
							header('X-Sendfile: '.$filename);
							header('Content-type: application/octet-stream');
							header('Content-Disposition: attachment; filename="'.$filename_original.'"');
						} else {
							$length = filesize($filename);
							if (strstr($_SERVER["HTTP_USER_AGENT"],"MSIE")) {
								header("Pragma: public");
								header("Expires: 0");
								header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
								header("Content-type: application-download");
								header("Content-Length: ".$length);
								header("Content-Disposition: attachment; filename=\"".$filename_original."\"");
								header("Content-Transfer-Encoding: binary");
							} else {
								header("Content-type: application-download");
								header("Content-Length: ".$length);
								header("Content-Disposition: attachment; filename=\"".$filename_original."\"");
							}
							$handle_read = fopen($filename, "rb");
							while (!feof($handle_read) && $length > 0) {
								$content = fread($handle_read, 1024);
								echo substr($content, 0, min($length, 1024));
								flush();
								ob_flush();
								$length = $length - strlen($content);
								if ($length < 0) $length = 0;
							}
							fclose($handle_read);
						}
					} else {
						header('Location: '.wp_get_attachment_url($attachment_id));
						exit;
					}
				} else {
					header('Location: '.$_url);
					exit;
				}
				break;
			case 'url':
				//if (strlen($_file) > 0 && preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $_file)) {
					header('Location: '.$_file);
					exit;
				//} else {
				//	header('Location: '.$_url);
				//	exit;
				//}
				break;
			case 'amazon-s3':
				if (!empty($this->options['amazon_access_key']) && !empty($this->options['amazon_secret_key']) && !empty($this->options['amazon_bucket'])) {
					$amazon_url = $this->amazon_url($this->options['amazon_access_key'], $this->options['amazon_secret_key'], $this->options['amazon_bucket'], $_file, 24);
					header('Location: '.$amazon_url);
					exit;
				} else {
					header('Location: '.$_url);
					exit;
				}
				break;
			case 'file':
				error_reporting(0);
				ob_start();
				if(!ini_get('safe_mode')) set_time_limit(0);
				ob_end_clean();
				$upload_dir = wp_upload_dir();
				$filename = $upload_dir["basedir"].DIRECTORY_SEPARATOR.OPD_UPLOADS_DIR.DIRECTORY_SEPARATOR.$_file;
				if (!file_exists($filename) || !is_file($filename)) {
					header('Location: '.$_url);
					exit;
				}
				if ($this->options['xsendfile'] == 'on') {
					header('X-Sendfile: '.$filename);
					header('Content-type: application/octet-stream');
					header('Content-Disposition: attachment; filename="'.$_file.'"');
				} else {
					$length = filesize($filename);
					if (strstr($_SERVER["HTTP_USER_AGENT"],"MSIE")) {
						header("Pragma: public");
						header("Expires: 0");
						header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
						header("Content-type: application-download");
						header("Content-Length: ".$length);
						header("Content-Disposition: attachment; filename=\"".$_file."\"");
						header("Content-Transfer-Encoding: binary");
					} else {
						header("Content-type: application-download");
						header("Content-Length: ".$length);
						header("Content-Disposition: attachment; filename=\"".$_file."\"");
					}
					ob_end_clean();
					$handle_read = fopen($filename, "rb");
					while (!feof($handle_read) && $length > 0) {
						$content = fread($handle_read, 1024);
						echo substr($content, 0, min($length, 1024));
						flush();
						ob_flush();
						$length = $length - strlen($content);
						if ($length < 0) $length = 0;
					}
					fclose($handle_read);
				}
				exit;
				break;
			default:
				header('Location: '.$_url);
				exit;
				break;
		}
		exit;
	}
	
	function random_string($_length = 16) {
		$symbols = '123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$string = "";
		for ($i=0; $i<$_length; $i++) {
			$string .= $symbols[rand(0, strlen($symbols)-1)];
		}
		return $string;
	}
	
}
$opd = new opd_class();
?>